/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSUInteger, FSPDFScanToolbarType) {
    ///< The bottom toolbar of document editing viewcontroller.
    FSPDFScanToolbarTypeBottombar,
};

NS_ASSUME_NONNULL_BEGIN

@interface PDFScanToolbarManager : NSObject

/** @brief Add FSMainToolbar for toolbar type.
 *
 *  @param[in]    toolbar        The  toolbar.
 *  @param[in]    toolbarType        The toolbar type that supports toolbar. Please refer to {@link FSPDFScanToolbarType FSPDFScanToolbarTypeXXX} values and it would be one of these values.
*/
- (void)setToolbar:(FSMainToolbar*)toolbar forToolbarType:(FSPDFScanToolbarType)toolbarType;
/** @brief Get mainToolbar  with the toolbar type.
 *
 *  @param[in]    toolbarType        The toolbar type that supports the toolbar. Please refer to {@link FSPDFScanToolbarType FSPDFScanToolbarTypeXXX} values and it would be one of these values.
 *
 *  @return     The object of FSMainToolbar.
*/
- (FSMainToolbar*)getToolbar:(FSPDFScanToolbarType)toolbarType;

@end

NS_ASSUME_NONNULL_END
