/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@protocol FSCameraThumbnailViewDalegate <NSObject>
- (void)didSelectItemOfCollectionView:(NSIndexPath *)indexPath;
- (void)deleteItemOfCollectionView: (NSInteger) itemIndex;
@end

@interface FSCameraThumbnailView : UIView
@property (nonatomic, strong) NSMutableArray* arrayImages;
@property (nonatomic, weak) id<FSCameraThumbnailViewDalegate> delegate;
@property (nonatomic, strong) NSIndexPath* selectPath;
- (void)resetSelect;
@end

NS_ASSUME_NONNULL_END
