/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <uiextensionsDynamic/uiextensionsDynamic.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FSMainToolbarScanItemType) {
    FSMainToolbarScanItemTypeAddFile = FSMainToolbarItemTypeUnknown + 1,
    FSMainToolbarScanItemTypeSaveFile,
};

@interface FSMainToolbarItem (PDFScanPrivate)
@property (nonatomic, assign) FSMainToolbarScanItemType itemType;
@property (nonatomic, weak, readonly) FSItem *item;
@end

@interface FSMainToolbar (PDFScanPrivate)
@property (nonatomic, strong, readonly) FSToolbar *toolbar;
- (instancetype)initWithStyle:(FSToolbarStyle)style;
- (FSMainToolbarItem *)getToolbarItemForItemType:(FSMainToolbarScanItemType)itemType;
@end


NS_ASSUME_NONNULL_END
