/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import "FXImagePickThumbnailCell.h"

@interface FXImagePickThumbnailCell ()
@property (nonatomic, strong) UIImageView *thumbnailImageView;
@property (nonatomic, strong) UIImageView *selectImageView;
@property (nonatomic, strong) UIImageView* selectImageBGView;//backgroud view
@end

@implementation FXImagePickThumbnailCell

- (id)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame]) {
        self.isAccessibilityElement = YES;
        self.frame = CGRectMake(0, 0, DEVICE_iPHONE ? 78 : 132, DEVICE_iPHONE ? 78 : 132);
        self.backgroundColor = self.fs_backgroundColor_B1;
        _thumbnailImageView = [[UIImageView alloc] init];
        _thumbnailImageView.contentMode = UIViewContentModeScaleAspectFill;
        _thumbnailImageView.clipsToBounds = YES;
        _thumbnailImageView.frame = CGRectMake(0, 0,DEVICE_iPHONE ? 78 : 132, DEVICE_iPHONE ? 78 : 132);
        [self addSubview:_thumbnailImageView];
        
        _selectImageBGView = [[UIImageView alloc] init];
        [_selectImageBGView setImage:ImageNamed(@"scan_radio_unselected")];
        [self addSubview:_selectImageBGView];
        
        _selectImageView = [[UIImageView alloc] init];
        _selectImageView.highlighted = YES;
        [self.contentView addSubview:_selectImageView];
       
        [_selectImageView setImage:ImageNamed(@"scan_radio_unselected") ];
        [BindThemeKeySel(_selectImageView, setHighlightedImage:) fs_updateThemeCompleted:^(UIImageView * _Nonnull _item, SEL  _Nonnull sel) {
            [_item setHighlightedImage:[ImageNamed(@"scan_radio_selected") fs_imageWithTintColor:_item.fs_primaryColor]];
        }];
        [self addSubview:_selectImageView];
        
        [_selectImageBGView mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(self.selectImageBGView.superview.mas_left).offset(0);
            make.top.mas_equalTo(self.selectImageBGView.superview.mas_top).offset(0);
            make.size.mas_equalTo(CGSizeMake(40, 40));
        }];
        
        [_selectImageView mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(self.selectImageBGView.mas_left);
            make.top.mas_equalTo(self.selectImageBGView.mas_top);
            make.size.mas_equalTo(CGSizeMake(40, 40));
        }];
        
        self.accessibilityIdentifier = @"item_selected_name";
    }
    return self;
}

- (void)setThumbImage:(UIImage *)thumbImage
{
    _thumbImage = thumbImage;
    _thumbnailImageView.image = _thumbImage;   
}

- (void)setIsHighlight:(BOOL)isHighlight
{
    _selectImageView.highlighted = isHighlight;
    _isHighlight = isHighlight;
}

- (void)setIsDisable:(BOOL)isDisable
{
    _isDisable = isDisable;
    if (isDisable) {
        _thumbnailImageView.alpha = 0.4;
        //self.userInteractionEnabled = NO;
    }else{
        _thumbnailImageView.alpha = 1.0;
        //self.userInteractionEnabled = YES;
    }
}
@end
