/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef PDFScanMenuViewManager_Private_h
#define PDFScanMenuViewManager_Private_h

#import "PDFScanMenuViewManager.h"

@interface PDFScanMenuItem ()
@property (nonatomic, assign) NSInteger actionTag;
- (instancetype)initWithTitle:(NSString *)title image:(UIImage *)image actionTag:(NSInteger)tag;
@end

@interface PDFScanMenuViewManager ()

@end


#ifndef ImageNamed
    #define ImageNamed(name) ({\
    UIImage.fs_bundleForClass = [PDFScanMenuViewManager class];\
    [UIImage fs_imageNamed:name];})
#endif

#ifndef ImageNamedAndColor
    #define ImageNamedAndColor(name, color) ({\
    UIImage.fs_bundleForClass = [PDFScanMenuViewManager class];\
    [UIImage fs_imageNamed:name tintColor:color];})
#endif

#ifndef ImageNamedAndNormalColor
    #define ImageNamedAndNormalColor(name) ({\
        NSObject *weakObj = [NSObject new];\
        ImageNamedAndColor(name, weakObj.fs_iconColor_I3);})
#endif

#ifndef ImageNamedAndDisabledColor
    #define ImageNamedAndDisabledColor(name) ({\
        NSObject *weakObj = [NSObject new];\
        ImageNamedAndColor(name, weakObj.fs_iconColor_I2);})
#endif

#ifndef ImageNamedAndPrimaryColor
    #define ImageNamedAndPrimaryColor(name) ({\
        NSObject *weakObj = [NSObject new];\
        ImageNamedAndColor(name, weakObj.fs_primaryColor);})
#endif

#endif /* PDFScanMenuViewManager_Private_h */
