//
//  LTDocumentEditViewControllerNew.m
//  FoxitApp
//
//  Created by Apple on 16/12/1.
//
//

#import "pageCollectionViewCell.h"
#import "LTCollectionViewScaleHelper.h"

#import "LTPageFormatHelper.h"
#import "LTDefaultFilenameProvider.h"

#import "LTDocumentEditViewControllerNew.h"
//#import "LTEditDocumentName.h"
//#import <ENSDK/ENSDK.h>
#import "PDFScanManager+private.h"
#import "UITableView+EmptyData.h"
#import "FSPreferences.h"
#import "FSMainToolbar+PDFScanPrivate.h"
#import "FSCustomViewContainerController.h"
#import "FSScanSaveAsViewController.h"

@interface LTDocumentEditViewControllerNew ()<UIGestureRecognizerDelegate ,UIPopoverControllerDelegate>

@property (weak, nonatomic) UICollectionViewCell* addPageCell;
//@property (nonatomic, strong) LTImageProcessor* imageProcessor;

@property (nonatomic) LTCollectionViewScaleHelper* scaleHelper;
@property (nonatomic, copy) NSString *documentName;
@property (nonatomic) int pageInProcessor;
@property (nonatomic, assign) BOOL isEditing;

@property (nonatomic, strong) FSToolbar *topBar;
@property (nonatomic, strong) FSMainToolbar *bottomBar;
@property (nonatomic, strong) FSToolbar *bottomDeleteBar;

@property (nonatomic, strong) FSItem *addPageItem;
@property (nonatomic, strong) FSItem *saveItem;
@property (nonatomic, strong) FSItem *deleteItem;
@property (nonatomic, strong) FSItem *replaceItem;

@property (nonatomic, strong) UIButton *discardBtn;
@property (nonatomic, strong) UIButton *editBtn;
@property (nonatomic, strong) UIButton *doneBtn;
@property (nonatomic, strong) UIButton *selectAllBtn;
@property (nonatomic, strong) UIButton *fileNameBtn;
@property (nonatomic, strong) FSItem *selectedNum;

@property (nonatomic, strong) NSMutableArray *selectedArray;
//@property (nonatomic, assign) BOOL isDiscard;
@property (nonatomic, assign) BOOL isSave;
@property (nonatomic, assign) BOOL isSavePicture;
@property (nonatomic, assign) BOOL isReloadDocument;
@property (nonatomic, strong) NSString *savedPath;

@property (nonatomic, strong) UIView *fileNameLine;
@property (nonatomic, strong) NSString *oldFileName;
@property (nonatomic, strong) NSArray<FSMainToolbarItem*>* customBottomItemsArray;
@property (nonatomic, strong) FSCustomViewContainerController* customViewForSaveAs;
@end

@implementation LTDocumentEditViewControllerNew

- (void)viewDidLoad {
    [super viewDidLoad];
    _isReloadDocument = NO;
    _isEditing = NO;
    if (self.documentSession.isNewDocument && self.documentSession.rename == nil) {
        _documentName = [@"Scan " stringByAppendingString:[LTDefaultFilenameProvider timeBasedFilename]];
        _documentName = [LTDefaultFilenameProvider filterFileNameSpecialCharactor:_documentName];
    }else{
        if (self.documentSession.rename != nil) {
            _documentName = self.documentSession.rename;
        }else{
            _documentName = self.documentSession.documentName;
        }
    }
    [self initSubViews];
    
    
    // Do any additional setup after loading the view.
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self.collectionView reloadData];
    if (self.documentSession.pageCount < 1) {
        _saveItem.enabled  = NO;
    }else{
        _saveItem.enabled = YES;
    }
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    if (self.documentSession) {
        self.documentSession.delegate = self;
    }
}

- (void)dismissViewControllerAnimated:(BOOL)flag completion:(void (^)(void))completion
{
    [super dismissViewControllerAnimated:flag completion:completion];
    
}

- (void)initSubViews
{
    FSToolbar *topbar = [[FSToolbar alloc] initWithStyle:FSToolbarStyleTop];
    _topBar = topbar;
    [self.view addSubview:topbar];
    [topbar mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.mas_equalTo(topbar.superview);
    }];
    
    [self initTopbar:topbar];
    _bottomBar = [[PDFScanManager shareManager].toolbarManager getToolbar:FSPDFScanToolbarTypeBottombar];
    FSToolbar *bottomBar = _bottomBar.toolbar;
    if (_bottomBar) {
        bottomBar = _bottomBar.toolbar;
        [self.view addSubview:bottomBar];
        [bottomBar mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.right.bottom.mas_equalTo(bottomBar.superview);
        }];
        [self initBottombar:_bottomBar];
    }
    
    FSToolbar *bottomDeleteBar = [[FSToolbar alloc] initWithStyle:FSToolbarStyleBottom];
    _bottomDeleteBar = bottomDeleteBar;
    [self.view addSubview:bottomDeleteBar];
    [bottomDeleteBar mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.mas_equalTo(bottomDeleteBar.superview);
      
    }];
    [self initBottomDeleteBar:bottomDeleteBar];
    [bottomDeleteBar setHidden:YES];
    
    
    
    RACollectionViewReorderableTripletLayout *raLayout = [[RACollectionViewReorderableTripletLayout alloc] init];
    self.collectionView = [[UICollectionView alloc] initWithFrame:self.view.bounds collectionViewLayout:raLayout];
    self.collectionView.backgroundColor = self.fs_backgroundColor_B1;
    self.view.backgroundColor = self.fs_backgroundColor_B1;
    raLayout.itemSize = CGSizeMake(DEVICE_iPHONE ? 78 : 152 , DEVICE_iPHONE ? 98 : 172);
    raLayout.minimumLineSpacing = 0;
    raLayout.minimumInteritemSpacing = 2;
    raLayout.delegate = self;
    raLayout.datasource = self;
    [self.view addSubview:self.collectionView];
    [self.collectionView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(topbar.fs_mas_left);
        make.right.mas_equalTo(topbar.fs_mas_right);
        make.bottom.mas_equalTo(bottomDeleteBar.mas_top);
        make.top.mas_equalTo(topbar.mas_bottom);
    }];
    
    [self.collectionView registerClass:[pageCollectionViewCell class] forCellWithReuseIdentifier:@"pageCellId"];
}

- (UIStatusBarStyle)preferredStatusBarStyle
{
    return UIStatusBarStyleDefault;
}

- (void)initTopbar:(FSToolbar *)topBar
{
    UIButton *discardBtn = [[UIButton alloc] init];
    _discardBtn = discardBtn;
    [BindThemeKeySel(discardBtn, setImage:forState:) fs_updateThemeCompleted:^(UIButton*  _Nonnull target, SEL  _Nonnull sel) {
        [target setImage:[ImageNamed(@"scan_back_white") fs_imageWithTintColor:target.fs_primaryColor] forState:UIControlStateNormal];
        [target setImage:[[ImageNamed(@"scan_back_white") fs_imageWithTintColor:target.fs_primaryColor] fs_applyingAlpha:IMAGE_HIGHLIGHTED_ALPHA] forState:UIControlStateHighlighted];
    }];
    
    [discardBtn addTarget:self action:@selector(discardBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [topBar addSubview:discardBtn];
    [discardBtn setAccessibilityLabel:FSLocalizedForKey(@"kBack")];
    
    [discardBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(discardBtn.superview.mas_left).offset(4);
        make.centerY.mas_equalTo(discardBtn.superview);
        make.width.mas_equalTo(40);
        make.height.mas_equalTo(40);
    }];
    
    UIButton *selectAllBtn = [[UIButton alloc] init];
    _selectAllBtn = selectAllBtn;
    //_selectAllBtn.accessibilityLabel = FSLocalizedForKey(@"kSelectAll");
    selectAllBtn.hidden = YES;
    
    [selectAllBtn setTitle:FSLocalizedForKey(@"kSelectAll") forState:UIControlStateNormal];
    selectAllBtn.titleLabel.lineBreakMode = NSLineBreakByTruncatingTail;
    [selectAllBtn setTitle:FSLocalizedForKey(@"kDeselectAll") forState:UIControlStateSelected];
    [BindThemeKeySel(selectAllBtn, setTitleColor:forState:) fs_updateThemeCompleted:^(UIButton*  _Nonnull target, SEL  _Nonnull sel) {
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateSelected];
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateNormal];
        [target setTitleColor:[target.fs_primaryColor colorWithAlphaComponent:LABEL_HIGHLIGHTED_ALPHA] forState:UIControlStateHighlighted];
    }];
    selectAllBtn.titleLabel.font = self.fs_standardGeneralFont_GF2;
    selectAllBtn.titleLabel.textAlignment = NSTextAlignmentLeft;
    selectAllBtn.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
    [selectAllBtn addTarget:self action:@selector(selectAllBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [topBar addSubview:selectAllBtn];

    [selectAllBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(selectAllBtn.superview).offset(15);
        make.centerY.mas_equalTo(selectAllBtn.superview);
        make.height.mas_equalTo(40);
        make.width.mas_equalTo(110*SCREEN_WIDTH/375);
    }];
    UIButton *editBtn = [[UIButton alloc] init];
    editBtn.accessibilityLabel = FSLocalizedForKey(@"kEdit");
    editBtn.titleLabel.lineBreakMode = NSLineBreakByTruncatingTail;
    [editBtn setTitle:FSLocalizedForKey(@"kEdit") forState:UIControlStateNormal];
    [BindThemeKeySel(editBtn, setTitleColor:forState:) fs_updateThemeCompleted:^(UIButton*  _Nonnull target, SEL  _Nonnull sel) {
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateSelected];
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateNormal];
        [target setTitleColor:[target.fs_primaryColor colorWithAlphaComponent:LABEL_HIGHLIGHTED_ALPHA] forState:UIControlStateHighlighted];
    }];
    
    [editBtn setTitleColor:self.fs_textColor_T2 forState:UIControlStateDisabled];
    editBtn.titleLabel.font = self.fs_standardGeneralFont_GF2;
    editBtn.titleLabel.textAlignment = NSTextAlignmentRight;
    [editBtn addTarget:self action:@selector(editBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    _editBtn = editBtn;
    
    [topBar addSubview:editBtn];
    [editBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(editBtn.superview).offset(-14);
        make.centerY.mas_equalTo(discardBtn);
        make.height.mas_equalTo(40);
    }];
    
    UIButton *doneBtn = [[UIButton alloc] init];
    doneBtn.hidden = YES;
    _doneBtn = doneBtn;
    doneBtn.titleLabel.lineBreakMode = NSLineBreakByTruncatingTail;
    [doneBtn setTitle:FSLocalizedForKey(@"kDone") forState:UIControlStateNormal];
    [BindThemeKeySel(doneBtn, setTitleColor:forState:) fs_updateThemeCompleted:^(UIButton*  _Nonnull target, SEL  _Nonnull sel) {
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateSelected];
        [target setTitleColor:target.fs_primaryColor forState:UIControlStateNormal];
        [target setTitleColor:[target.fs_primaryColor colorWithAlphaComponent:LABEL_HIGHLIGHTED_ALPHA] forState:UIControlStateHighlighted];
    }];
    doneBtn.titleLabel.font = self.fs_standardGeneralFont_GF2;
    doneBtn.titleLabel.textAlignment = NSTextAlignmentRight;
    [doneBtn addTarget:self action:@selector(doneBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [topBar addSubview:doneBtn];
    [doneBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(doneBtn.superview).offset(-15);
        make.centerY.mas_equalTo(doneBtn.superview);
        make.height.mas_equalTo(40);
    }];

    UIButton *fileNameBtn = [[UIButton alloc] init];
    fileNameBtn.accessibilityIdentifier = @"scan_pdf_name";
    _fileNameBtn = fileNameBtn;
    [fileNameBtn setTitle:_documentName forState:UIControlStateNormal];
    [fileNameBtn setTitleColor:self.fs_textColor_T4 forState:UIControlStateNormal];
    [fileNameBtn setTitleColor:self.fs_textColor_T2 forState:UIControlStateHighlighted];
    fileNameBtn.titleLabel.font = self.fs_standardGeneralFont_GF1;
    fileNameBtn.titleLabel.textAlignment = NSTextAlignmentCenter;
    [fileNameBtn addTarget:self action:@selector(fileNameBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [topBar addSubview:fileNameBtn];
    [fileNameBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.center.mas_equalTo(fileNameBtn.superview);
        make.height.mas_equalTo(44);
        make.left.mas_greaterThanOrEqualTo(discardBtn.mas_right).offset(10);
        make.right.mas_lessThanOrEqualTo(editBtn.mas_left).offset(-10);
    }];
    
    NSString* text = [NSString stringWithFormat:FSLocalizedForKey(@"kFormatSelected"),0];
    FSItem* selectedNum = [FSItem createItemWithTitle:text];
    selectedNum.accessibilityTraits = UIAccessibilityTraitNone;
    selectedNum.customAccessibilityTraits = UIAccessibilityTraitNone;
    [topBar addItem:selectedNum atPosition:FSItemPositionCenter];
    _selectedNum = selectedNum;
    [selectedNum setHidden:YES];
    
    UIView *fileNameLine = [[UIView alloc] init];
    _fileNameLine = fileNameLine;
    fileNameLine.backgroundColor = self.fs_textColor_T4; 
    
    CGRect stringRect = [fileNameBtn.titleLabel.text boundingRectWithSize:CGSizeMake(1000, 44) options:NSStringDrawingUsesFontLeading attributes:@{NSFontAttributeName:fileNameBtn.titleLabel.font} context:NULL];
    [fileNameBtn addSubview:fileNameLine];
    [fileNameLine mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.centerX.mas_equalTo(fileNameLine.superview.mas_centerX);
        make.height.mas_equalTo(1);
        make.bottom.mas_equalTo(fileNameLine.superview.mas_bottom).offset(-((44 - stringRect.size.height) * 0.5 - 1));
        make.width.equalTo(fileNameBtn).priorityHigh();
        make.width.lessThanOrEqualTo(fileNameBtn);
    }];
}

- (void)initBottombar:(FSMainToolbar *)bottomBar
{
    _addPageItem = [bottomBar getToolbarItemForItemType:FSMainToolbarScanItemTypeAddFile].item;
    _addPageItem.accessibilityLabel = FSLocalizedForKey(@"kKeepScanVoiceover");
    _addPageItem.accessibilityIdentifier = @"add_page_item";
    @weakify(self)
    _addPageItem.onTapClick = ^(FSItem *item){
        @strongify(self);
        if (self->_isDocumentEditModel) {
            NSString *mediaType = AVMediaTypeVideo;
            AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];
            if (authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied)
            {
                
              UIAlertController *alert = [UIAlertController fs_alertWithTitle:FSLocalizedForKey(@"kNotAllowTakePhoto") message:FSLocalizedForKey(@"kCAMERADenied") actions:@[ FSLocalizedForKey(@"kCancel"), FSLocalizedForKey(@"kGoSetting") ] actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                    if (index == 1){
                        NSURL*url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                        if([[UIApplication sharedApplication] canOpenURL:url]) {
                            [[UIApplication sharedApplication] openURL:url];
                        }
                    }
                }];
                [self presentViewController:alert animated:YES completion:nil];
                 return;
            }else if (authStatus == AVAuthorizationStatusNotDetermined){
                [AVCaptureDevice requestAccessForMediaType:AVMediaTypeVideo completionHandler:^(BOOL granted) {
                    dispatch_async(dispatch_get_main_queue(), ^{
                        if (granted) {
                            LTCanmeraViewControllerNew* cameraView = [[LTCanmeraViewControllerNew alloc] init];
                            cameraView.documentSession = self->_documentSession;
                            cameraView.isOpenFromEditor = YES;
                            [self presentViewController:cameraView animated:YES completion:nil];
                        }else{
                            UIAlertController *alert = [UIAlertController fs_alertWithTitle:FSLocalizedForKey(@"kNotAllowTakePhoto") message:FSLocalizedForKey(@"kCAMERADenied") actions:@[ FSLocalizedForKey(@"kCancel"), FSLocalizedForKey(@"kGoSetting")] actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                                   if (index == 1){
                                        NSURL *url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                                        if([[UIApplication sharedApplication] canOpenURL:url]) {
                                            [[UIApplication sharedApplication] openURL:url];
                                        }
                                    }
                              }];
                              [self presentViewController:alert animated:YES completion:nil];
                            return;
                        }
                    });
                }];
            }else{
                LTCanmeraViewControllerNew* cameraView = [[LTCanmeraViewControllerNew alloc] init];
                cameraView.documentSession = self->_documentSession;
                cameraView.isOpenFromEditor = YES;
                cameraView.modalPresentationStyle = UIModalPresentationFullScreen;
                [self presentViewController:cameraView animated:YES completion:nil];
            }
        }else{
            if (self->_isReloadDocument && self.addPageDocumentReload) {
                self.addPageDocumentReload(self->_documentSession);
            }
            [self.navigationController popViewControllerAnimated:YES];
        }
    };

    _saveItem = [bottomBar getToolbarItemForItemType:FSMainToolbarScanItemTypeSaveFile].item;
    _saveItem.accessibilityLabel = FSLocalizedForKey(@"kSaveAs");
    _saveItem.accessibilityIdentifier = @"saveas_item";
    _saveItem.onTapClick = ^(FSItem *item){
        @strongify(self);
        [self saveAs];
    };

}

- (void)initBottomDeleteBar:(FSToolbar *)bottomBar
{
    FSItem *replaceItem = [FSItem createItemWithImage:ImageNamedAndNormalColor(@"scan_image_replace") imageSelected:ImageNamedAndNormalColor(@"scan_image_replace") imageDisable:ImageNamedAndDisabledColor(@"scan_image_replace")];
    replaceItem.accessibilityLabel = FSLocalizedForKey(@"kReplace");
    _replaceItem = replaceItem;
    [bottomBar addItem:replaceItem atPosition:FSItemPositionCenter];
    @weakify(self)
    replaceItem.onTapClick = ^(FSItem *item){
        @strongify(self)
        NSString *mediaType = AVMediaTypeVideo;
        AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];
        if (authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied)
        {
            
            UIAlertController *alert = [UIAlertController fs_alertWithTitle:FSLocalizedForKey(@"kNotAllowTakePhoto") message:FSLocalizedForKey(@"kCAMERADenied") actions:@[ FSLocalizedForKey(@"kCancel"), FSLocalizedForKey(@"kGoSetting") ] actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                if (index == 1){
                    NSURL*url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                    if([[UIApplication sharedApplication] canOpenURL:url]) {
                        [[UIApplication sharedApplication] openURL:url options:@{} completionHandler:nil];
                    }
                }
            }];
            [self presentViewController:alert animated:YES completion:nil];
            return;
        }else if (authStatus == AVAuthorizationStatusNotDetermined){
            [AVCaptureDevice requestAccessForMediaType:AVMediaTypeVideo completionHandler:^(BOOL granted) {
                dispatch_async(dispatch_get_main_queue(), ^{
                    if (granted) {
                        LTCanmeraViewControllerNew* cameraView = [[LTCanmeraViewControllerNew alloc] init];
                        cameraView.replaceCallBack = ^(UIImage *replaceImage) {
                            if (replaceImage) {
                                BOOL find = NO;
                                int selectPage = 0;
                                for (int i =0; i < self.documentSession.pageCount; i++) {
                                    if ([self->_selectedArray[i] boolValue]) {
                                        selectPage = i;
                                        find = YES;
                                        break;
                                    }
                                }
                                if (!find) return;
                                [self.documentSession replacePage:selectPage withImage:replaceImage];
                                [self.collectionView reloadData];
                            }
                        };
                        //cameraView.documentSession = self->_documentSession;
                        cameraView.isOpenFromEditor = YES;
                        [self presentViewController:cameraView animated:YES completion:nil];
                    }else{
                        UIAlertController *alert = [UIAlertController fs_alertWithTitle:FSLocalizedForKey(@"kNotAllowTakePhoto") message:FSLocalizedForKey(@"kCAMERADenied") actions:@[ FSLocalizedForKey(@"kCancel"), FSLocalizedForKey(@"kGoSetting")] actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                            if (index == 1){
                                NSURL *url =[NSURL URLWithString:UIApplicationOpenSettingsURLString];
                                if([[UIApplication sharedApplication] canOpenURL:url]) {
                                    [[UIApplication sharedApplication] openURL:url options:@{} completionHandler:nil];
                                }
                            }
                        }];
                        [self presentViewController:alert animated:YES completion:nil];
                        return;
                    }
                });
            }];
        }else{
            LTCanmeraViewControllerNew* cameraView = [[LTCanmeraViewControllerNew alloc] init];
            cameraView.replaceCallBack = ^(UIImage *replaceImage) {
                if (replaceImage) {
                    BOOL find = NO;
                    int selectPage = 0;
                    for (int i =0; i < self.documentSession.pageCount; i++) {
                        if ([self->_selectedArray[i] boolValue]) {
                            selectPage = i;
                            find = YES;
                            break;
                        }
                    }
                    if (!find) return;
                    [self.documentSession replacePage:selectPage withImage:replaceImage];
                    [self.collectionView reloadData];
                }
            };
            cameraView.isOpenFromEditor = YES;
            cameraView.modalPresentationStyle = UIModalPresentationFullScreen;
            [self presentViewController:cameraView animated:YES completion:nil];
        }
    };
    
    FSItem *deleteItem = [FSItem createItemWithImage:ImageNamedAndNormalColor(@"scan_edit_delete") imageSelected:ImageNamedAndNormalColor(@"scan_edit_delete") imageDisable:ImageNamedAndDisabledColor(@"scan_edit_delete")];
    deleteItem.accessibilityLabel = FSLocalizedForKey(@"kDelete");
    _deleteItem = deleteItem;
    [bottomBar addItem:deleteItem atPosition:FSItemPositionCenter];
    deleteItem.onTapClick = ^(FSItem *item){
        @strongify(self);
        [UIAlertController fs_alertWithTitle:FSLocalizedForKey(@"kConfirm") message:FSLocalizedForKey(@"kDeleteFileMsg") actions:@[FSLocalizedForKey(@"kCancel"), FSLocalizedForKey(@"kOK")] actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
            if (index == 1) {
                for (int i =0; i < self.documentSession.pageCount; i++) {
                    if ([self->_selectedArray[i] boolValue]) {
                        [self.documentSession removePage:i];
                        [self->_selectedArray removeObjectAtIndex:i];
                        i--;
                    }
                }
                ((FSItem*)self->_replaceItem).enabled = NO;
                ((FSItem*)self->_deleteItem).enabled = NO;
                self->_selectAllBtn.selected = NO;
                if (self.documentSession) {
                    if (self.documentSession.pageCount > 0) {
                        self->_selectAllBtn.enabled = YES;
                    }else{
                        self->_selectAllBtn.enabled = NO;
                    }
                }else{
                    self->_selectAllBtn.enabled = NO;
                }
                [self.collectionView reloadData];
                if (self.documentSession.pageCount < 1) {
                    ((FSItem*)self->_saveItem).enabled = NO;
                }else{
                    ((FSItem*)self->_saveItem).enabled = YES;
                }
                
                [self showSelectedNumWhenEditing];
            }
        } onCtrl:self];
    };
}


- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 1;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    [collectionView fs_collectionDisplayWitMsg:FSLocalizedForKey(@"kAddNewScanImageTip") ifNecessaryForRowCount:self.documentSession.pageCount];
    self.selectAllBtn.enabled = self.documentSession.pageCount;
    self.editBtn.enabled = self.documentSession.pageCount;
    ScanPDFSessionPageCountChangeCallBack pagecountCallBack = [PDFScanManager pageCountCallBack];
    if (pagecountCallBack) {
        pagecountCallBack(self.documentSession.pageCount);
    }
    if (self.documentSession.pageCount) {
        return self.documentSession.pageCount;
    }
    [self.doneBtn sendActionsForControlEvents:UIControlEventTouchUpInside];
    return 0;//_photosArray.count;
}

- (CGFloat)reorderingItemAlpha:(UICollectionView *)collectionview
{
    return .3f;
}

- (CGSize)collectionView:(UICollectionView *)collectionView sizeForLargeItemsInSection:(NSInteger)section
{
    return CGSizeZero;
}

- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section {
    return UIEdgeInsetsMake(12, 24, 12, 24);
}

- (void)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout didEndDraggingItemAtIndexPath:(NSIndexPath *)indexPath
{
    [self.collectionView reloadData];
}

- (void)collectionView:(UICollectionView *)collectionView itemAtIndexPath:(NSIndexPath *)fromIndexPath didMoveToIndexPath:(NSIndexPath *)toIndexPath
{
    [_documentSession movePage:(int)fromIndexPath.item toIndex:(int)toIndexPath.item];
}

- (BOOL)collectionView:(UICollectionView *)collectionView itemAtIndexPath:(NSIndexPath *)fromIndexPath canMoveToIndexPath:(NSIndexPath *)toIndexPath
{
    if (_isEditing) {
        return NO;
    }
    return YES;
}

- (BOOL)collectionView:(UICollectionView *)collectionView canMoveItemAtIndexPath:(NSIndexPath *)indexPath
{
    if (_isEditing) {
        return NO;
    }
    return YES;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellID = @"pageCellId";
    pageCollectionViewCell *cell = [self.collectionView dequeueReusableCellWithReuseIdentifier:cellID forIndexPath:indexPath];
    
    //cell.backgroundColor = [UIColor yellowColor];
    cell.thumbImage = [_documentSession thumbnailForPage:(int)indexPath.item];//_arrImageCollection[indexPath.item];
    if (cell.thumbImage == nil) cell.thumbImage = [_documentSession imageForPage:(int)indexPath.item];
    cell.pageIndex = indexPath.item + 1;
    cell.isSelected = NO;
    if (_isEditing) {
        cell.isEditing = YES;
        cell.isSelected = [[_selectedArray objectAtIndex:indexPath.row] boolValue];
    }else{
        cell.isEditing = NO;
    }
    [cell.contentView setAccessibilityLabel:[NSString stringWithFormat:@"%ld",cell.pageIndex]];
    [cell.contentView setAccessibilityTraits:UIAccessibilityTraitButton];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    if (_isEditing) {
        pageCollectionViewCell *cell = (pageCollectionViewCell *)[collectionView cellForItemAtIndexPath:indexPath];
        cell.isSelected = !cell.isSelected;
        _selectedArray[indexPath.item] = [NSNumber numberWithBool:cell.isSelected];
        BOOL isAllSelected = YES;
        
        for (NSNumber *value in _selectedArray) {
            if (![value boolValue]) {
                isAllSelected = NO;
                break;
            }
        }
        _selectAllBtn.selected = isAllSelected;
        
        BOOL hasSelected = NO;
        for (NSNumber *value in _selectedArray) {
            if ([value boolValue]) {
                hasSelected = YES;
                break;
            }
        }
        ((FSItem*)_deleteItem).enabled = hasSelected;
        
        int selectCount = 0;
        for (NSNumber *value in _selectedArray) {
            if ([value boolValue]) {
                selectCount++;
                if (selectCount > 1) break;
            }
        }
        ((FSItem*)_replaceItem).enabled = (selectCount == 1);
        
        [self showSelectedNumWhenEditing];
    }else{
        UIImage *editImage = [_documentSession imageForPage:(int)indexPath.item];
        LTImageProcessViewControllerNew *imageProcessViewControllerNew = [[LTImageProcessViewControllerNew alloc] initWithImage:editImage isPresent:NO];
        imageProcessViewControllerNew.delegate = self;
        _pageInProcessor = (int)indexPath.item;
        [self.navigationController pushViewController:imageProcessViewControllerNew animated:YES];
    }
    [collectionView reloadData];
}

- (void)processImageView:(LTImageProcessViewControllerNew *)ctrl didFinishWithResult:(UIImage *)image
{
    if (image) {
        [self.documentSession replacePage:_pageInProcessor withImage:image];
        [self.collectionView reloadData];
    }
}

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldReceiveTouch:(UITouch *)touch
{
    return YES;
}

#pragma mark ------topbar btn click event------
- (void)discardBtnClick:(UIButton *)btn
{
    if (self.discardCompelet) {
        self.discardCompelet();
    }
    
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)fileNameBtnClick:(UIButton *)btn
{
    if (_documentSession.pageCount > 0) {
        [self renameScaneFile:btn.titleLabel.text];
    }
}

- (void)renameScaneFile:(NSString *)fileName
{
    NSString *msg = FSLocalizedForKey(@"kInputNewName");
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:FSLocalizedForKey(@"kRename") message:msg preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *renameaction = [UIAlertAction actionWithTitle:FSLocalizedForKey(@"kOK") style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        NSString *newfileName = alertController.textFields.firstObject.text;
        NSString *newFile = [newfileName stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
        
        if (newFile == nil || newFile.length == 0)
        {
            FSAlertViewCtrlShow(@"kWarning", @"kInputNewFileName");
            return;
        }
        
        if ([newFile rangeOfCharacterFromSet:[NSCharacterSet characterSetWithCharactersInString:@"\\/:*?\\\\<>|"]].location != NSNotFound)
        {
            [UIAlertController fs_alert_OK_WithTitle:@"kWarning" message:@"kIllegalNameWarning" actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                [self renameScaneFile:newFile];
            }onCurrentSceneResponder:self];
            return;
        }
        
       self->_documentName = newFile;
       [self.fileNameBtn setTitle:newFile forState:UIControlStateNormal];
       self.documentSession.rename = newFile;
       CGRect stringRect = [self.fileNameBtn.titleLabel.text boundingRectWithSize:CGSizeMake(1000, 44) options:NSStringDrawingUsesFontLeading attributes:@{NSFontAttributeName:self->_fileNameBtn.titleLabel.font} context:NULL];
       [self->_fileNameLine mas_remakeConstraints:^(MASConstraintMaker *make) {
           make.centerX.mas_equalTo(self->_fileNameLine.superview.mas_centerX);
           make.height.mas_equalTo(1);
           make.bottom.mas_equalTo(self->_fileNameLine.superview.mas_bottom).offset(-((44 - stringRect.size.height) * 0.5 - 1));
           make.width.mas_equalTo(stringRect.size.width + 5).priorityHigh();
           make.width.lessThanOrEqualTo(self->_fileNameLine.superview);
       }];
       
       self->_oldFileName = self.documentSession.documentName;
        
    }];
    renameaction.enabled = NO;
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:FSLocalizedForKey(@"kCancel") style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
    }];
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        textField.accessibilityIdentifier = @"input_new_file_name_box";
        textField.text = [fileName stringByDeletingPathExtension];
        textField.clearButtonMode = UITextFieldViewModeWhileEditing;
        [textField setBlockForControlEvents:UIControlEventEditingChanged block:^(UITextField * _Nonnull sender) {
            renameaction.enabled = ![sender.text isEqualToString:self.fileNameBtn.titleLabel.text];
            renameaction.enabled = ![sender.text isEqualToString:@""];
        }];
    }];
    [alertController addAction:cancel];
    [alertController addAction:renameaction];
    [self presentViewController:alertController animated:YES completion:nil];
}

- (void)editBtnClick:(UIButton *)btn
{
    self.isEditing = YES;
    btn.hidden = YES;
    _doneBtn.hidden = NO;
    
    if (self.documentSession) {
        if (self.documentSession.pageCount > 0) {
            _selectAllBtn.enabled = YES;
        }else{
            _selectAllBtn.enabled = NO;
        }
    }else{
        _selectAllBtn.enabled = NO;
    }
    [self showSelectedNumWhenEditing];
}

- (void)doneBtnClick:(UIButton *)btn
{
    self.isEditing = NO;
    btn.hidden = YES;
    _editBtn.hidden = NO;
}

- (void)selectAllBtnClick:(UIButton *)btn
{
    btn.selected = !btn.selected;
    if (btn.selected) {
        for (int i = 0; i < self.documentSession.pageCount; i++) {
            NSNumber *value = [NSNumber numberWithBool:YES];
            _selectedArray[i] = value;
        }
        ((FSItem*)_deleteItem).enabled = YES;
        ((FSItem*)_replaceItem).enabled = (_selectedArray.count == 1);
    }else{
        for (int i = 0; i < self.documentSession.pageCount; i++) {
            NSNumber *value = [NSNumber numberWithBool:NO];
            _selectedArray[i] = value;
        }
        ((FSItem*)_deleteItem).enabled = NO;
        ((FSItem*)_replaceItem).enabled = NO;
    }
    [self.collectionView reloadData];
    [self showSelectedNumWhenEditing];
}

- (void)setCustomBottomItemsHidden:(BOOL)isHidden
{
    if (self.customBottomItemsArray) {
        for (int i = 0; i < self.customBottomItemsArray.count; i++) {
            [self.customBottomItemsArray[i].item setHidden:isHidden];
        }
    }
}

- (void)setIsEditing:(BOOL)isEditing
{
    _isEditing = isEditing;
    [_bottomBar.toolbar setHidden:isEditing];
    [_bottomDeleteBar setHidden:!isEditing];
    if (isEditing) {
        _selectedArray = [NSMutableArray arrayWithCapacity:self.documentSession.pageCount];
        
        for (int i = 0; i < self.documentSession.pageCount; i++) {
            NSNumber *value = [NSNumber numberWithBool:NO];
            [_selectedArray addObject:value];
        }
        _deleteItem.enabled = NO;
        _replaceItem.enabled = NO;
        _selectAllBtn.hidden = NO;
        _discardBtn.hidden = YES;
        _fileNameLine.hidden = YES;
        _fileNameBtn.hidden = YES;
        _selectedNum.hidden = NO;
        
    }else{
        [_selectedArray removeAllObjects];
        _selectedArray = nil;
        _selectAllBtn.hidden = YES;
        _discardBtn.hidden = NO;
        _fileNameLine.hidden = NO;
        _fileNameBtn.hidden = NO;
        _selectedNum.hidden = YES;
    }
    [self setCustomBottomItemsHidden:isEditing];
    _selectAllBtn.selected = NO;
    [self.collectionView reloadData];
}

- (void)saveAs{
    id<PDFScanMenuView> customView = [[PDFScanManager shareManager].menuViewManager getMenuViewForMenuViewType:PDFScanMenuViewTypeSaveAs];
    FSCustomViewContainerController * controller = nil;
    if (customView) {
        controller = [[FSCustomViewContainerController alloc] initWithParams:[customView getCustomView]];
        customView.containerController = controller;
        FSNavigationController *nav = [[FSNavigationController alloc] initWithRootViewController:customView.containerController];
        if (DEVICE_iPHONE)
        {
            nav.modalPresentationStyle = UIModalPresentationFullScreen;
        }
        else
        {
            nav.modalPresentationStyle = UIModalPresentationFormSheet;
        }
        [self presentViewController:nav animated:YES completion:nil];
        
        return;
    }
    
    _isSave = NO;
    NSString *fileName = [_documentName stringByAppendingString:@".pdf"];
    
    NSString *filePath = [[PDFScanManager shareManager].documentPath stringByAppendingPathComponent:fileName];
    
    FSScanSaveAsViewController *saveAsVC = [[FSScanSaveAsViewController alloc] init];
    FSNavigationController *nav = [[FSNavigationController alloc] initWithRootViewController:saveAsVC];
    saveAsVC.isScanSave = YES;
    saveAsVC.saveAsCallBack = ^(NSError * _Nonnull error, NSString * _Nonnull savePath) {
        self.savedPath = savePath;
        NSString *fileNameWithoutType = [[savePath lastPathComponent] stringByDeletingPathExtension];
        [self.documentSession saveAsPDF:fileNameWithoutType];
        LTDocumentManager *documentManager = [PDFScanManager shareManager].documentManager;
        for (LTDocument *document in documentManager.documents) {
            if ([document.documentName isEqualToString:self.documentName]) {
                [documentManager removeDocument:document];
                break;
            }
        }
    };
    [saveAsVC setPdfFilePath:filePath];

    if (DEVICE_iPHONE)
    {
        nav.modalPresentationStyle = UIModalPresentationFullScreen;
    }
    else
    {
        nav.modalPresentationStyle = UIModalPresentationFormSheet;
    }
    [self presentViewController:nav animated:YES completion:nil];
}

- (void) documentSession:(LTDocumentSession*) session startedSavingDocumentToFile:(NSString*) documentName
{
    [self.view fs_showHUDLoading:nil];
}

- (void) documentSession:(LTDocumentSession*) session didFinishSavingDocument:(LTDocument*) document
{
    [self.view fs_hideHUDLoading];
    LTDocumentManager *documentManager = [[PDFScanManager shareManager] documentManager];
    [documentManager addDocument:document];

    if (_oldFileName.length > 0 && ![_oldFileName isEqualToString:document.documentName]) {
        if ([self fileWithNameDoesExist:_oldFileName]) {
            [documentManager removeDocument:[documentManager documentByName:_oldFileName]];
        }
        _oldFileName = nil;
    }
    
    if ([[PDFScanManager shareManager] savePDFFlieWithRealFilePath:document.urlForDocument.path]) {
        return;
    }
    
    if (self.savedPath.length) {
        NSString *realSaveAsPath = document.urlForDocument.path;
        NSError *error = nil;
        if (![self.savedPath isEqualToString:realSaveAsPath]) {
            [[NSFileManager defaultManager] copyItemAtPath:realSaveAsPath toPath:self.savedPath error:&error];
        }
        if(!error){
            [UIAlertController fs_alert_OK_WithTitle:@"kSaveSuccess" message:@"" actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                !PDFScanManager.saveAsCallBack ? : PDFScanManager.saveAsCallBack(error , self.savedPath);
            } onCurrentSceneResponder:self];
        }else{
            [UIAlertController fs_alert_OK_WithTitle:@"kFailed" message:@"" actionBack:^(NSUInteger index, UIAlertAction * _Nonnull action) {
                !PDFScanManager.saveAsCallBack ? : PDFScanManager.saveAsCallBack(error , self.savedPath);
            }onCurrentSceneResponder:self];
        }
    }else{
        if (_isSavePicture) {
            _isSavePicture = NO;
            if (_isDocumentEditModel) {
                [self.navigationController popViewControllerAnimated:NO];
            }else{
                [self.navigationController popViewControllerAnimated:NO];
                if (self.normalModelSavedDocument) {
                    self.normalModelSavedDocument();
                }
            }
        }
    }
}

- (BOOL)fileWithNameDoesExist:(NSString*) filename
{
    return [[PDFScanManager shareManager].documentManager documentByName:filename] != nil;
}

- (void)showSelectedNumWhenEditing
{
    NSInteger selectedNum = 0;
    for (NSNumber *value in _selectedArray) {
       if ([value boolValue]) {
           selectedNum ++;
        }
    }
    
    NSString* str = [NSString stringWithFormat:FSLocalizedForKey(@"kFormatSelected"),selectedNum];
    [_selectedNum setTitle:str forState:UIControlStateNormal];
}


- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
    
    [_selectAllBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(_selectAllBtn.superview).offset(15);
        make.centerY.mas_equalTo(_selectAllBtn.superview);
        make.height.mas_equalTo(40);
        make.width.mas_equalTo(110*SCREEN_WIDTH/375);
    }];
}
@end
