//
//  pageCollectionViewCell.m
//  FoxitApp
//
//  Created by Apple on 16/12/1.
//
//

#import "pageCollectionViewCell.h"
#import "FSPreferences.h"

@interface pageCollectionViewCell ()
@property (nonatomic, strong) UIImageView *pageImageView;
@property (nonatomic, strong) UIImageView* selectImageView;
@property (nonatomic, strong) UIImageView* selectImageBGView;//backgroud view
@property (nonatomic, strong) UILabel *indexLabel;
@end

@implementation pageCollectionViewCell

- (id)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame]) {
//        UIView *viewcon = [[UIView alloc] init];
//        self.contentView.isAccessibilityElement = NO;
//        [self.contentView addSubview:viewcon];
//        [viewcon mas_makeConstraints:^(MASConstraintMaker *make) {
//            make.edges.mas_equalTo(viewcon.superview);
//        }];
        
        UILabel *indexLabel = [[UILabel alloc] init];
        _indexLabel = indexLabel;
        indexLabel.textAlignment = NSTextAlignmentCenter;
        indexLabel.textColor = self.fs_textColor_T4;
        indexLabel.font = self.fs_standardWeakFont_WF1;
        [self.contentView addSubview:indexLabel];
        [indexLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(indexLabel.superview.mas_left);
            make.right.mas_equalTo(indexLabel.superview.mas_right);
            make.bottom.mas_equalTo(indexLabel.superview.mas_bottom);
            make.height.mas_equalTo(20);
        }];
        
        _pageImageView = [[UIImageView alloc] init];
        _pageImageView.contentMode = UIViewContentModeScaleAspectFit;
        [self.contentView addSubview:_pageImageView];
        [_pageImageView mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(_pageImageView.superview.mas_left);
            make.right.mas_equalTo(_pageImageView.superview.mas_right);
            make.top.mas_equalTo(_pageImageView.superview.mas_top);
            make.bottom.mas_equalTo(indexLabel.mas_top);
        }];
        
        _selectImageBGView = [[UIImageView alloc] init];
        [_selectImageBGView setImage:ImageNamed(@"scan_radio_unselected")];
        [self.contentView addSubview:_selectImageBGView];
        
        
        _selectImageView = [[UIImageView alloc] init];
        _selectImageView.highlighted = YES;
        [self.contentView addSubview:_selectImageView];
       
        [_selectImageView setImage:ImageNamed(@"scan_radio_unselected") ];
        [BindThemeKeySel(_selectImageView, setHighlightedImage:) fs_updateThemeCompleted:^(UIImageView * _Nonnull _item, SEL  _Nonnull sel) {
            [_item setHighlightedImage:[ImageNamed(@"scan_radio_selected") fs_imageWithTintColor:_item.fs_primaryColor]];
        }];
        
        
        _pageIndex = 0;
        _isSelected = NO;
        _isEditing = NO;
        self.contentView.isAccessibilityElement = YES;
    }
    return self;
}

- (void)setIsSelected:(BOOL)isSelected
{
    _selectImageView.highlighted = isSelected;
    _isSelected = isSelected;
}

- (void)setIsEditing:(BOOL)isEditing
{
    _isEditing = isEditing;
    [_selectImageView setHidden:!isEditing];
    [_selectImageBGView setHidden:!isEditing];
}

- (void)setThumbImage:(UIImage *)thumbImage
{
    CGFloat width = self.frame.size.width;
    CGFloat height = self.frame.size.height - 20;
    _pageImageView.image = thumbImage;
    CGFloat fImageN = thumbImage.size.width/thumbImage.size.height;
    CGFloat fCellN = width/height;
    CGFloat fImageWidth = 0;
    CGFloat fImageHeight = 0;
    if (fImageN >= fCellN)
    {
        fImageWidth = width;
        fImageHeight = fImageWidth*(thumbImage.size.height/thumbImage.size.width);
    }
    else
    {
        fImageHeight = height;
        fImageWidth = fImageHeight*(thumbImage.size.width/thumbImage.size.height);
    }
   
    CGFloat fx = (width - fImageWidth)/2;
    CGFloat fy = (height - fImageHeight)/2;
    [_selectImageBGView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.selectImageBGView.superview.mas_left).offset(fx);
        make.top.mas_equalTo(self.selectImageBGView.superview.mas_top).offset(fy);
        make.size.mas_equalTo(CGSizeMake(40, 40));
    }];
    
    [_selectImageView mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.selectImageBGView.mas_left);
        make.top.mas_equalTo(self.selectImageBGView.mas_top);
        make.size.mas_equalTo(CGSizeMake(40, 40));
    }];
}

- (void)setPageIndex:(NSInteger)pageIndex
{
    _indexLabel.text = [NSString stringWithFormat:@"%ld",(long)pageIndex];
    _pageIndex = pageIndex;
}

- (void)setHighlighted:(BOOL)highlighted
{
    [super setHighlighted:highlighted];
    if (highlighted) {
        self.alpha = 0.5;
    }
    else {
        self.alpha = 1.f;
    }
}

@end
