//
//  LTSliderBar.h
//  FoxitPDFScanUI
//
//  Created by Wei Zheng on 2021/1/21.
//  Copyright © 2021 foxitcorporation. All rights reserved.
//

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN
@class LTSliderBar;
@protocol LTSliderBarDelegate <NSObject>

- (void)sliderValueChange:(LTSliderBar*)sliderBar value:(float)value;

@end

@interface LTSliderBar : UIView

@property (nonatomic, assign) float currentValue;

@property (nonatomic, weak) id<LTSliderBarDelegate> delegate;

- (instancetype)initWithSliderData:(UIColor*)maximumTrackTintColor thumbTintColor:(UIColor*)thumbTintColor sliderValueBGImgName:(NSString*)sliderValueBGImgName;

- (void)setSliderValue:(float)value minimumValue:(float)minimumValue maximumValue:(float)maximumValue minimumValueForShow:(float)minimumValueForShow maximumValueForShow:(float)maximumValueForShow;

- (void)setSliderCurrentValue:(float)value;
@end

NS_ASSUME_NONNULL_END
