/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

/**
 * @file    FSUtilities.h
 * @details    Macros of constants or helper functions. Shared among the public headers.
 */

#if defined(__cplusplus)
    #define FS_EXTERN extern "C"
#else
    #define FS_EXTERN extern
#endif

/** @brief ui emlement types. */
typedef NS_ENUM(NSUInteger, FSUIElementType) {
    /** @brief The FSUIElementReadingPanel. */
    FSUIElementReadingPanel = 20000,
    /** @brief The FSUIElementReadingPanelBookmark. */
    FSUIElementReadingPanelBookmark,
    /** @brief The FSUIElementReadingPanelOutline. */
    FSUIElementReadingPanelOutline,
    /** @brief The FSUIElementReadingPanelComment. */
    FSUIElementReadingPanelComment,
    /** @brief The FSUIElementReadingPanelAttachment. */
    FSUIElementReadingPanelAttachment,
    /** @brief The FSUIElementReadingPanelDigitalSignature. */
    FSUIElementReadingPanelDigitalSignature,
    /** @brief The FSUIElementReadingView. */
    FSUIElementReadingView,
    /** @brief The FSUIElementReadingViewSinglePage. */
    FSUIElementReadingViewSinglePage,
    /** @brief The FSUIElementReadingViewFacing. */
    FSUIElementReadingViewFacing,
    /** @brief The FSUIElementReadingViewCoverFacing. */
    FSUIElementReadingViewCoverFacing,
    /** @brief The FSUIElementReadingViewDay. */
    FSUIElementReadingViewDay,
    /** @brief The FSUIElementReadingViewNight. */
    FSUIElementReadingViewNight,
    /** @brief The FSUIElementReadingViewPageColor. */
    FSUIElementReadingViewPageColor,
    /** @brief The FSUIElementReadingViewContinuousScrolling. */
    FSUIElementReadingViewContinuousScrolling,
    /** @brief The FSUIElementReadingViewFitPage. */
    FSUIElementReadingViewFitPage,
    /** @brief The FSUIElementReadingViewFitWidth. */
    FSUIElementReadingViewFitWidth,
    /** @brief The FSUIElementReadingViewReflow. */
    FSUIElementReadingViewReflow,
    /** @brief The FSUIElementReadingViewCropMode. */
    FSUIElementReadingViewCropMode,
    /** @brief The FSUIElementReadingViewSpeak. */
    FSUIElementReadingViewSpeak,
    /** @brief The FSUIElementReadingViewAutoFlip. */
    FSUIElementReadingViewAutoFlip,
    /** @brief The FSUIElementReadingViewRotateView. */
    FSUIElementReadingViewRotateView,
    /** @brief The FSUIElementReadingViewPanZoom. */
    FSUIElementReadingViewPanZoom,
    /** @brief The FSUIElementReadingViewPageRTL. */
    FSUIElementReadingViewPageRTL,
    /** @brief The FSUIElementReadingThumbnial. */
    FSUIElementReadingThumbnial,
    /** @brief The FSUIElementReadingBookmark. */
    FSUIElementReadingBookmark,
    /** @brief The FSUIElementReadingShare. */
    FSUIElementReadingShare,
    /** @brief The FSUIElementReadingRecentList. */
    FSUIElementReadingRecentList,
    /** @brief The FSUIElementReadingToolsTabHome. */
    FSUIElementReadingToolsTabHome,
    /** @brief The FSUIElementReadingToolsTabEdit. */
    FSUIElementReadingToolsTabEdit,
    /** @brief The FSUIElementReadingToolsTabComment. */
    FSUIElementReadingToolsTabComment,
    /** @brief The FSUIElementReadingToolsTabDrawing. */
    FSUIElementReadingToolsTabDrawing,
    /** @brief The FSUIElementReadingToolsTabView. */
    FSUIElementReadingToolsTabView,
    /** @brief The FSUIElementReadingToolsTabForm. */
    FSUIElementReadingToolsTabForm,
    /** @brief The FSUIElementReadingToolsTabFillSign. */
    FSUIElementReadingToolsTabFillSign,
    /** @brief The FSUIElementReadingHomeBarAddTools. */
    FSUIElementReadingHomeBarAddTools,
    /** @brief The FSUIElementReadingToolbarMultipleSelection. */
    FSUIElementReadingToolbarMultipleSelection,
    /** @brief The FSUIElementReadingEditBarText. */
    FSUIElementReadingEditBarText,
    /** @brief The FSUIElementReadingEditBarImage. */
    FSUIElementReadingEditBarImage,
    /** @brief The FSUIElementReadingEditBarAudio. */
    FSUIElementReadingEditBarAudio,
    /** @brief The FSUIElementReadingEditBarVideo. */
    FSUIElementReadingEditBarVideo,
    /** @brief The FSUIElementReadingCommentBarNote. */
    FSUIElementReadingCommentBarNote,
    /** @brief The FSUIElementReadingCommentBarAttachment. */
    FSUIElementReadingCommentBarAttachment,
    /** @brief The FSUIElementReadingCommentBarStamp. */
    FSUIElementReadingCommentBarStamp,
    /** @brief The FSUIElementReadingCommentBarTypeWriter. */
    FSUIElementReadingCommentBarTypeWriter,
    /** @brief The FSUIElementReadingCommentBarCallout. */
    FSUIElementReadingCommentBarCallout,
    /** @brief The FSUIElementReadingCommentBarTextbox. */
    FSUIElementReadingCommentBarTextbox,
    /** @brief The FSUIElementReadingCommentBarHighlight. */
    FSUIElementReadingCommentBarHighlight,
    /** @brief The FSUIElementReadingCommentBarUnderline. */
    FSUIElementReadingCommentBarUnderline,
    /** @brief The FSUIElementReadingCommentBarSquiggly. */
    FSUIElementReadingCommentBarSquiggly,
    /** @brief The FSUIElementReadingCommentBarStrikeout. */
    FSUIElementReadingCommentBarStrikeout,
    /** @brief The FSUIElementReadingCommentBarInsertText. */
    FSUIElementReadingCommentBarInsertText,
    /** @brief The FSUIElementReadingCommentBarReplaceText. */
    FSUIElementReadingCommentBarReplaceText,
    /** @brief The FSUIElementReadingCommentBarAreaHighlight. */
    FSUIElementReadingCommentBarAreaHighlight,
    /** @brief The FSUIElementReadingCommentBarDistance. */
    FSUIElementReadingCommentBarDistance,
    /** @brief The FSUIElementReadingCommentBarImage. */
    FSUIElementReadingCommentBarImage,
    /** @brief The FSUIElementReadingDrawingBarPencil. */
    FSUIElementReadingDrawingBarPencil,
    /** @brief The FSUIElementReadingDrawingBarHighlight. */
    FSUIElementReadingDrawingBarHighlight,
    /** @brief The FSUIElementReadingDrawingBarEraser. */
    FSUIElementReadingDrawingBarEraser,
    /** @brief The FSUIElementReadingDrawingBarRectangle. */
    FSUIElementReadingDrawingBarRectangle,
    /** @brief The FSUIElementReadingDrawingBarOval. */
    FSUIElementReadingDrawingBarOval,
    /** @brief The FSUIElementReadingDrawingBarLine. */
    FSUIElementReadingDrawingBarLine,
    /** @brief The FSUIElementReadingDrawingBarArrow. */
    FSUIElementReadingDrawingBarArrow,
    /** @brief The FSUIElementReadingDrawingBarPolyline. */
    FSUIElementReadingDrawingBarPolyline,
    /** @brief The FSUIElementReadingDrawingBarPolygon. */
    FSUIElementReadingDrawingBarPolygon,
    /** @brief The FSUIElementReadingDrawingBarCloud. */
    FSUIElementReadingDrawingBarCloud,
    /** @brief The FSUIElementReadingFormBarTextField. */
    FSUIElementReadingFormBarTextField,
    /** @brief The FSUIElementReadingFormBarCheckBox. */
    FSUIElementReadingFormBarCheckBox,
    /** @brief The FSUIElementReadingFormBarRadioButton. */
    FSUIElementReadingFormBarRadioButton,
    /** @brief The FSUIElementReadingFormBarListBox. */
    FSUIElementReadingFormBarListBox,
    /** @brief The FSUIElementReadingFormBarComboBox. */
    FSUIElementReadingFormBarComboBox,
    /** @brief The FSUIElementReadingFormBarSignatureField. */
    FSUIElementReadingFormBarSignatureField,
    /** @brief The FSUIElementReadingFormBarImageField. */
    FSUIElementReadingFormBarImageField,
    /** @brief The FSUIElementReadingFormBarReset. */
    FSUIElementReadingFormBarReset,
    /** @brief The FSUIElementReadingAnnotPopMenuAppearance. */
    FSUIElementReadingAnnotPopMenuAppearance,
    /** @brief The FSUIElementReadingAnnotPopMenuDelete. */
    FSUIElementReadingAnnotPopMenuDelete,
    /** @brief The FSUIElementReadingFillSignTypeWriter. */
    FSUIElementReadingFillSignTypeWriter,
    /** @brief The FSUIElementReadingFillSignComboText. */
    FSUIElementReadingFillSignComboText,
    /** @brief The FSUIElementReadingFillSignV. */
    FSUIElementReadingFillSignV,
    /** @brief The FSUIElementReadingFillSignX. */
    FSUIElementReadingFillSignX,
    /** @brief The FSUIElementReadingFillSignDot. */
    FSUIElementReadingFillSignDot,
    /** @brief The FSUIElementReadingFillSignRectangle. */
    FSUIElementReadingFillSignRectangle,
    /** @brief The FSUIElementReadingFillSignLine. */
    FSUIElementReadingFillSignLine,
    /** @brief The FSUIElementReadingFillSignPredefined. */
    FSUIElementReadingFillSignPredefined,
    /** @brief The FSUIElementReadingFillSignSign. */
    FSUIElementReadingFillSignSign,
    /** @brief The FSUIElementReadingSearch. */
    FSUIElementReadingSearch,
    /** @brief The FSUIElementReadingMoreFileProperty. */
    FSUIElementReadingMoreFileProperty,
    /** @brief The FSUIElementReadingMoreProtectRedaction. */
    FSUIElementReadingMoreProtectRedaction,
    /** @brief The FSUIElementReadingMoreProtectFileEncryption. */
    FSUIElementReadingMoreProtectFileEncryption,
    /** @brief The FSUIElementReadingMoreProtectTrustedCertificates. */
    FSUIElementReadingMoreProtectTrustedCertificates,
    /** @brief The FSUIElementReadingMoreProtectCertificateProtect. */
    FSUIElementReadingMoreProtectCertificateProtect,
    /** @brief The FSUIElementReadingMoreProtectRMSProtect. */
    FSUIElementReadingMoreProtectRMSProtect,
    /** @brief The FSUIElementReadingMoreCommentFieldImortComments. */
    FSUIElementReadingMoreCommentFieldImortComments,
    /** @brief The FSUIElementReadingMoreCommentFieldExportComments. */
    FSUIElementReadingMoreCommentFieldExportComments,
    /** @brief The FSUIElementReadingMoreCommentFieldSummarizeComments. */
    FSUIElementReadingMoreCommentFieldSummarizeComments,
    /** @brief The FSUIElementReadingMoreCommentFieldExportHighlightedText. */
    FSUIElementReadingMoreCommentFieldExportHighlightedText,
    /** @brief The FSUIElementReadingMoreCommentFieldResetFormFields. */
    FSUIElementReadingMoreCommentFieldResetFormFields,
    /** @brief The FSUIElementReadingMoreCommentFieldImportFormFields. */
    FSUIElementReadingMoreCommentFieldImportFormFields,
    /** @brief The FSUIElementReadingMoreCommentFieldExportFormFields. */
    FSUIElementReadingMoreCommentFieldExportFormFields,
    /** @brief The FSUIElementReadingMoreSaveAs. */
    FSUIElementReadingMoreSaveAs,
    /** @brief The FSUIElementReadingMoreExportPDF. */
    FSUIElementReadingMoreExportPDF,
    /** @brief The FSUIElementReadingMoreReduceFileSize. */
    FSUIElementReadingMoreReduceFileSize,
    /** @brief The FSUIElementReadingMoreTags. */
    FSUIElementReadingMoreTags,
    /** @brief The FSUIElementReadingMorePrint. */
    FSUIElementReadingMorePrint,
    /** @brief The FSUIElementReadingMoreFlatten. */
    FSUIElementReadingMoreFlatten,
    /** @brief The FSUIElementReadingMoreScreenCapture. */
    FSUIElementReadingMoreScreenCapture,
    /** @brief The FSUIElementReadingLongPressComment. */
    FSUIElementReadingLongPressComment,
    /** @brief The FSUIElementReadingLongPressRedaction. */
    FSUIElementReadingLongPressRedaction,
    /** @brief The FSUIElementReadingLongPressSign. */
    FSUIElementReadingLongPressSign,
    /** @brief The FSUIElementReadingLongPressCopyText. */
    FSUIElementReadingLongPressCopyText,
    /** @brief The FSUIElementReadingLongPressHighlight. */
    FSUIElementReadingLongPressHighlight,
    /** @brief The FSUIElementReadingLongPressUnderline. */
    FSUIElementReadingLongPressUnderline,
    /** @brief The FSUIElementReadingLongPressStrikeout. */
    FSUIElementReadingLongPressStrikeout,
    /** @brief The FSUIElementReadingLongPressSquiggly. */
    FSUIElementReadingLongPressSquiggly,
    /** @brief The FSUIElementReadingLongPressSpeak. */
    FSUIElementReadingLongPressSpeak,
    /** @brief The FSUIElementReadingGotoPage. */
    FSUIElementReadingGotoPage,
    /** @brief The FSUIElementReadingFullScreenBookmark. */
    FSUIElementReadingFullScreenBookmark,
    /** @brief The FSUIElementReadingFullScreenToolbar. */
    FSUIElementReadingFullScreenToolbar,
    /** @brief The FSUIElementReadingFullScreenToolbarDrag. */
    FSUIElementReadingFullScreenToolbarDrag,
    /** @brief The FSUIElementReadingToolbarDrag. */
    FSUIElementReadingToolbarDrag,
    /** @brief The FSUIElementReadingFreeTrial. */
    FSUIElementReadingFreeTrial,
    FSUIElementReadingInkRecognitionText
};

/** @brief States of extensions manager. */
typedef NS_ENUM(NSUInteger, FSUIManagerState) {
    ///< tag of normal ui state
    FSUIManagerStateNormal = 1,
    ///< tag of reflow ui state
    FSUIManagerStateReflow,
    ///< tag of search ui state
    FSUIManagerStateSearch,
    ///< tag of annottool ui state
    FSUIManagerStateAnnotTool,
    ///< tag of panandzoom state
    FSUIManagerStatePanZoom,
    ///< tag of create form state
    FSUIManagerStateCreateForm,
    ///< tag of panandzoom state
    FSUIManagerStateSpeech,
    ///< tag of fill sign state
    FSUIManagerStateFillSign,
    ///< tag of auto flip
    FSUIManagerStateAutoFlip,
    ///< tag of redaction ui state
    FSUIManagerStateRedaction,
    ///< tag of redaction pdf comparision
    FSUIManagerStateComparision,
    ///< tag of editor state
    FSUIManagerStateEditor
};

/** @brief Interactive scene.*/
typedef NS_ENUM(NSUInteger, FSInteractiveScene) {
    ///Undefine
    FSInteractiveSceneUndefine,
    ///When filling out the form.
    FSInteractiveSceneFillingForms,
};

/** @brief Constants that indicate sort order.*/
typedef NS_ENUM(NSUInteger, FSDataSortComparison) {
    ///The left operand is smaller than the right operand.
    FSDataSortOrderedAscending,
    ///The left operand is greater than the right operand.
    FSDataSortOrderedDescending,
};

/** @brief Customized annotation type on application level. */

FS_EXTERN const FSAnnotType FSAnnotArrowLine;     ///< tag of Arrow custom annot type
FS_EXTERN const FSAnnotType FSAnnotInsert;       ///< tag of Insert custom annot type
FS_EXTERN const FSAnnotType FSAnnotTextbox;      ///< tag of Textbox custom annot type
FS_EXTERN const FSAnnotType FSAnnotCloud;        ///< tag of Cloud custom annot type
FS_EXTERN const FSAnnotType FSAnnotCallout;      ///< tag of Callout custom annot type
FS_EXTERN const FSAnnotType FSAnnotDistance;     ///< tag of Distance custom annot type
FS_EXTERN const FSAnnotType FSAnnotReplace;      ///< tag of Replace custom annot type
FS_EXTERN const FSAnnotType FSAnnotReflow;      ///< tag of Reflow custom annot type

typedef NSString *FSStringName;
typedef FSStringName FSToolStringName;
FS_EXTERN FSToolStringName const Tool_Select;         ///< name of select tool
FS_EXTERN FSToolStringName const Tool_Note;             ///< name of note tool
FS_EXTERN FSToolStringName const Tool_Freetext;     ///< name of free text tool
FS_EXTERN FSToolStringName const Tool_Textbox;       ///< name of text box tool
FS_EXTERN FSToolStringName const Tool_Callout;       ///< name of callout tool
FS_EXTERN FSToolStringName const Tool_Pencil;         ///< name of pencil tool
FS_EXTERN FSToolStringName const Tool_Eraser;         ///< name of eraser tool
FS_EXTERN FSToolStringName const Tool_Stamp;           ///< name of stamp tool
FS_EXTERN FSToolStringName const Tool_Insert;         ///< name of insert text tool
FS_EXTERN FSToolStringName const Tool_Replace;       ///< name of replace text tool
FS_EXTERN FSToolStringName const Tool_Attachment; ///< name of attachment tool
FS_EXTERN FSToolStringName const Tool_Signature;   ///< name of signature tool
FS_EXTERN FSToolStringName const Tool_Line;             ///< name of line tool
FS_EXTERN FSToolStringName const Tool_Arrow;           ///< name of arrow line tool
FS_EXTERN FSToolStringName const Tool_Markup;         ///< name of markup tool, which includes highlight squiggly strikeout and underline tools
FS_EXTERN FSToolStringName const Tool_Highlight;   ///< name of highlight tool
FS_EXTERN FSToolStringName const Tool_Squiggly;     ///< name of squiggly tool
FS_EXTERN FSToolStringName const Tool_Strikeout;   ///< name of strikeout tool
FS_EXTERN FSToolStringName const Tool_Underline;   ///< name of underline tool
FS_EXTERN FSToolStringName const Tool_Shape;           ///< name of shape tool, which includes rectangle and oval tools
FS_EXTERN FSToolStringName const Tool_Rectangle;   ///< name of rectangle tool
FS_EXTERN FSToolStringName const Tool_Oval;             ///< name of oval tool
FS_EXTERN FSToolStringName const Tool_Distance;     ///< name of distance tool
FS_EXTERN FSToolStringName const Tool_Image;           ///< name of image tool
FS_EXTERN FSToolStringName const Tool_Polygon;       ///< name of polygon tool
FS_EXTERN FSToolStringName const Tool_Cloud;           ///< name of cloud tool
FS_EXTERN FSToolStringName const Tool_PolyLine;     ///< name of polyline tool
FS_EXTERN FSToolStringName const Tool_Audio;           ///< name of audio tool
FS_EXTERN FSToolStringName const Tool_Video;           ///< name of video tool
FS_EXTERN FSToolStringName const Tool_Link;           ///< name of Link tool
FS_EXTERN FSToolStringName const Tool_Multiple_Selection;           ///< name of MultipleSelection tool
FS_EXTERN FSToolStringName const Tool_Redaction;       ///< name of redact tool
FS_EXTERN FSToolStringName const Tool_Form;              ///< name of form tool
FS_EXTERN FSToolStringName const Tool_Fill_Sign;         ///< name of fill sign tool


typedef FSStringName FSModuleStringName;
FS_EXTERN FSModuleStringName const Module_Thumbnail;        ///< name of thumbnail module
FS_EXTERN FSModuleStringName const Module_Signature;        ///< name of signature module
FS_EXTERN FSModuleStringName const Module_Speech;
FS_EXTERN FSModuleStringName const Module_History_Data;    ///< name of history data module

/**@brief Defines existing-supplied images  for main tool bar items..*/
typedef int FS_TOOLBAR_ITEM_TAG;
///The back item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_BACK;
///The more item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_MORE;
///The search item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_SEARCH;
///The panel item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_PANEL;
///The view settings item. When FS_TOOLBAR_ITEM_TAG_VIEW_SETTINGS is hidden, FS_TOOLBAR_ITEM_TAG_VIEW is also hidden.
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_VIEW_SETTINGS;
///The Thumbnai item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_THUMBNAIL;
///The bookmark item
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_READING_BOOKMARK;
///The home tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_HOME;
///The edit tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_EDIT;
///The comment tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_COMMENT;
///The drawing tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_DRAWING;
///The view tag.  When FS_TOOLBAR_ITEM_TAG_VIEW is hidden, FS_TOOLBAR_ITEM_TAG_VIEW_SETTINGS is also hidden.
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_VIEW;
///The form tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_FORM;
///The sign tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_SIGN;
///The protect tag
FS_EXTERN const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_PROTECT;
