/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#if __has_include(<FSFoundation/FSFoundation.h>)
#import <FSFoundation/FSConst.h>
#else
#import "FSConst.h"
#endif

@class FSViewController;
@protocol FSNavigationProtocol <NSObject>

- (void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated;

- (void)popViewControllerAnimated:(BOOL)animated;

- (void)popToViewControllerClass:(Class)cls animated:(BOOL)animated;

- (void)popToRootViewControllerAnimated:(BOOL)animated;

- (void)presentViewController:(UIViewController *)viewController animated:(BOOL)animated completion:(VoidBlock)completion;

- (void)dismissViewControllerAnimated:(BOOL)animated completion:(VoidBlock)completion;

- (void)resetRootViewController:(UIViewController *)viewController;
@end
