/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPreferences.h"
#import "FSConst.h"
#import "FSEstimatedTableViewCell.h"

@implementation FSEstimatedTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier{
    self = [super initWithStyle:UITableViewCellStyleDefault reuseIdentifier:reuseIdentifier];
    if (self) {
        [self initialize];
    }
    return self;
}

- (void)initialize{
    
    [super initialize];
    
    self.titleDefaultTextColor = self.fs_textColor_T4;
    self.titleDefaultFont = self.fs_standardGeneralFont_GF2;
    
    self.subjectDefaultTextColor = self.fs_textColor_T3;
    self.subjectDefaultFont = self.fs_standardWeakFont_WF2;
    
    self.descriptionDefaultTextColor = self.fs_textColor_T2;
    self.descriptionDefaultFont = self.fs_standardWeakFont_WF1;
    
    _topMargin = ITEM_LABEL_TOP_MARGIN_NORMAL;
    _bottomMargin = ITEM_LABEL_BOTTOM_MARGIN_NORMAL;
    _leftMargin = ITEM_MARGIN_NORMAL;
    _mediumSpace = ITEM_MARGIN_NORMAL;
    _rightMargin = ITEM_TOP_ICON_MARGIN;
    _leftViewSzie = CGSizeZero;
}

- (void)installConstraints{
    _installed = YES;
}

- (void)reinstallConstraints{}

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
    
    [self initialize];
}

@end
