/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@class FSItem;
@interface FSTableViewCell : UITableViewCell

@property (nonatomic, strong) UIImage *editDragItemImage;
@property (nonatomic, strong, readonly, nullable) UIView *moreItem;
@property (nonatomic, strong, readonly) FSItem *editItem;

@property (nonatomic, strong) UIColor *selectedBackgroundColor;
@property (nonatomic, strong) UIColor *hightlightBackgroundColor;
@property (nonatomic, strong) UIColor *normalBackgroundColor;

//If it's zero then it's going to be in the center
@property (nonatomic, assign) CGFloat editTopOffset;
@property (nonatomic, assign) BOOL useCustomSeparator;
@property (nonatomic, assign) BOOL editingHiddenRightView;
@property (nonatomic, assign) BOOL hightlightBackgroundColorFillHor;

@property (nonatomic, weak) UITableView *supTableView;
@property (nonatomic, weak, readonly) NSIndexPath *indexPath;
@property (nonatomic, weak) id data;

- (void)initialize;
- (void)setHighlighted:(BOOL)highlighted custom:(BOOL)custom;
- (void)setHighlighted:(BOOL)highlighted color:(UIColor *)color custom:(BOOL)custom;

@end

NS_ASSUME_NONNULL_END
