/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSToolbar.h"

NS_ASSUME_NONNULL_BEGIN

@class FSItem;
typedef NS_ENUM(NSUInteger, FSNavigationBarShowStyle){
    FSNavigationBarShowStyleUnknow = 0,
    FSNavigationBarShowStylePush,
    FSNavigationBarShowStylePresent,
};


@protocol FSNavigationBarDelegate <NSObject>
- (void)navigationBarBackTouch;
@end

@interface FSNavigationBar : FSToolbar

- (instancetype)initWithShowStyle:(FSNavigationBarShowStyle)showStyle;

@property (nonatomic, weak) id<FSNavigationBarDelegate> delegate;

@property (nonatomic, readonly, strong, nullable) FSItem *leftItem;
@property (nonatomic, readonly, strong, nullable) FSItem *rightItem;

@property (nonatomic, readonly, strong, nullable) FSItem *titleItem;
@property (nonatomic, copy, nullable) NSString *title;

@property (nonatomic, assign, readonly) FSNavigationBarShowStyle showStyle;
- (void)updateItem;
@end

NS_ASSUME_NONNULL_END
