/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef FSToolbar_Private_h
#define FSToolbar_Private_h

#import "FSToolbar.h"
///like UILayoutGuide
@interface FSLayoutGuideHiddenBlankView : FSAdapterUIView @end

@interface FSToolbarItem : NSObject
@property (nonatomic, assign) CGFloat margin;
@property (nonatomic, strong) __kindof UIView *item;
@property (nonatomic, strong) MASConstraint *marginCconstraint;
- (instancetype)initWithItem:(__kindof UIView *)item marginCconstraint:(MASConstraint *)marginCconstraint;
@end

@interface FSToolbarItems : NSObject

@property (nonatomic, copy) NSArray<FSToolbarItem *> *items;
- (FSToolbarItem *)firstItem;
- (FSToolbarItem *)lastItem;
- (FSToolbarItem *)getItemForItem:(__kindof UIView *)item;
- (void)addItem:(FSToolbarItem *)item;
- (__kindof UIView *)getItemAtIndex:(NSUInteger)index;
- (BOOL)containsItem:(__kindof UIView *)item;
- (BOOL)removeItem:(__kindof UIView *)item;
@end

@interface FSToolbar ()
@property (nonatomic, weak) id<UIViewAdapter> adapter;
@property (nonatomic, strong) FSLayoutGuideHiddenBlankView *layoutGuideHiddenBlankViewLeft;//UIStackView will be even better
@property (nonatomic, strong) FSLayoutGuideHiddenBlankView *layoutGuideHiddenBlankViewCenter;//UIStackView will be even better
@property (nonatomic, strong) FSLayoutGuideHiddenBlankView *layoutGuideHiddenBlankViewRight;//UIStackView will be even better

@property (nonatomic, strong) FSToolbarItems *leftItems;
@property (nonatomic, strong) FSToolbarItems *centerItems;
@property (nonatomic, strong) FSToolbarItems *rightItems;


- (void)addItem:(__kindof UIView *)item margin:(CGFloat)margin spacing:(CGFloat)spacing atPosition:(FSItemPosition)position;
- (void)readdItemsForPosition:(FSItemPosition)position;
- (void)cleanAuxiliaryViewForPosition:(FSItemPosition)position;
@end

#endif /* FSToolbar_Private_h */
