/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSCornerRadiusStackView.h"

@interface FSCornerRadiusStackView ()
@property (nonatomic, strong) UIView *backgroundView;
@end
@implementation FSCornerRadiusStackView
+ (Class)layerClass{
    if (@available(iOS 14.0, *)){
        return [super layerClass];
    }else if (@available(iOS 13.0, *)){
        return [CALayer class];
    }
    return [super layerClass];
}

- (UIView *)backgroundView{
    if(!_backgroundView){
        _backgroundView = [UIView new];
        _backgroundView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
        [self insertSubview:_backgroundView atIndex:0];
    }
    return _backgroundView;
}

- (UIColor *)backgroundColor{
    if (@available(iOS 14.0, *)){
        return [super backgroundColor];
    }else{
        return self.backgroundView.backgroundColor;
    }
}

- (void)setBackgroundColor:(UIColor *)backgroundColor{
    if (@available(iOS 14.0, *)){
        [super setBackgroundColor:backgroundColor];
    }else{
        self.backgroundView.backgroundColor = backgroundColor;
    }
}
@end
