/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#if __has_include(<FSFoundation/FSFoundation.h>)
#import <FSFoundation/FSTableViewController.h>
#else
#import "FSTableViewController.h"
#endif

NS_ASSUME_NONNULL_BEGIN

@interface FSSearchViewController : FSTableViewController<UISearchBarDelegate>

@property (nonatomic, strong, readonly) UISearchBar *searchBar;
@property (nonatomic, strong, readonly) __kindof UIView *searchBarContentView;
@property (nonatomic, strong, readonly) NSPredicate *searchPredicate; //Matching keywords
@property (nonatomic, assign) NSTimeInterval searchInputInterval;

@property (nonatomic, assign, readonly) BOOL enteredSearch;
@property (nonatomic, strong, nullable) NSMutableArray *searchResultSoruce;
@property (nonatomic, copy, nullable) NSString *cancelTitle;
//search bar right item
@property (nonatomic, strong, readonly) FSItem *cancelItem;
@property (nonatomic, copy, nullable) NSString *keywords;
@property (nonatomic, copy, nullable) NSString *placeholder;

- (void)setSearchBarHidden:(BOOL)hidden;

- (BOOL)evaluateWithObject:(id)object;

- (void)enteredSearchState;
- (void)exitedSearchState;
- (void)clickedSearchCancelItem;

- (NSArray<UILabel *> *)keywordsHighlightLabels:(__kindof UITableViewCell *)cell;
@end

NS_ASSUME_NONNULL_END
