/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#if __has_include(<FSFoundation/FSFoundation.h>)
#import <FSFoundation/FSViewController.h>
#else
#import "FSViewController.h"
#endif

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FSPopoverShowStyle) {
    FSPopoverShowStyleDefault = 0,
    FSPopoverShowStyleStyleBubble,
};

typedef void(^FSWillRepositionPopoverToRectInView)(CGRect *rect, UIView **inView);

@interface FSViewPopoverController : FSViewController

@property (nonatomic, assign, readonly) FSPopoverShowStyle popoverShowStyle;

///The default is CGSizeZero, popoverSize has a higher priority than popoverWidth
@property (nonatomic, assign) CGSize popoverSize;
///The default is 0.f, popoverSize has a higher priority than popoverWidth
@property (nonatomic, assign) CGFloat popoverWidth;
//only FSPopoverShowStyleStyleBubble apply
@property (nonatomic, assign) BOOL autoresizesFollowContnetView;
//
@property (nonatomic, copy) FSWillRepositionPopoverToRectInView willRepositionPopoverToRectInView;

- (instancetype)initWithServices:(id<FSViewControllerServices>)services showStyle:(FSPopoverShowStyle)showStyle targetView:(UIView *)view;
- (instancetype)initWithServices:(id<FSViewControllerServices>)services showStyle:(FSPopoverShowStyle)showStyle targetViewController:(UIViewController *)targetViewController;
- (void)configureModalPresentationStyle;
- (void)setPopOverDismissCompletion:(VoidBlock)dismissCompletion;
@end

NS_ASSUME_NONNULL_END
