/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@protocol FSViewControllerServices;
@interface FSNavigationControllerStack : NSObject

- (instancetype)initWithServices:(id<FSViewControllerServices>)services;

- (void)pushNavigationController:(UINavigationController *)navigationController;
- (UINavigationController *)popNavigationController;
- (UINavigationController *)topNavigationController;
- (UINavigationController *)topVisibleNavigationController;
- (UINavigationController *)rootNavigationController;
- (NSArray<UINavigationController *> *)navigationControllers;
- (BOOL)containsNavigationController:(UINavigationController *)navigationController;
- (void)forcedPopNavigationController;
@end

NS_ASSUME_NONNULL_END
