/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import "NSArray+FSAdd.h"

@implementation NSArray (FSAdd)

- (BOOL)isExist{
    return self.count;
}

@end

@implementation NSMutableArray (Extensions)
- (void)fs_threadSafeAddObject:(id)anObject{
    @synchronized (self) {
        [self addObject:anObject];
    }
}

- (void)fs_insertObject:(id)object atIndex:(NSUInteger)index{
    if (!self.count || index > self.count - 1) {
        [self addObject:object];
        return;
    }
    [self insertObject:object atIndex:index];
}

- (void)fs_insertObjects:(NSArray *)otherArray atIndex:(NSUInteger)index{
    if (!self.count || index > self.count - 1) {
        [self addObjectsFromArray:otherArray];
        return;
    }
    NSMutableIndexSet *tmpSet = [NSMutableIndexSet indexSet];;
    for (int i = 0; i < otherArray.count; i ++ ) {
        NSUInteger loc =  i + index;
        [tmpSet addIndex:loc];
    }
    [self insertObjects:otherArray atIndexes:tmpSet];
}
@end

