/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@interface NSObject (Extensions)

//+ (UIWindow *)fs_getForegroundActiveWindowInSceneView:(UIView *)view;
+ (UIWindow *)fs_getForegroundAnyKeyWindow;
+ (CGRect)fs_getStatusBarFrame;
- (void)fs_addWeakAssociatedObject:(id)object forKey:(NSString *)key;
- (id)fs_getWeakAssociatedForKey:(NSString *)key;
- (void)fs_addCopyAssociatedObject:(id)object forKey:(NSString *)key;
- (void)fs_addAssociatedObject:(id)object forKey:(NSString *)key;
- (id)fs_getAssociatedForKey:(NSString *)key;
- (BOOL)fs_existKey:(NSString *)key;
- (__kindof UIViewController *)fs_storyBoardViewControllerWithName:(NSString *)name identifier:(NSString *)identifier;

@end

@interface NSObject (MultipleScenes)
#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 130000
@property (nonatomic, weak) UIWindowScene *fs_windowScene API_AVAILABLE(ios(13.0));
#endif
+ (BOOL)fs_currentDeviceIsPhone;
+ (BOOL)fs_currentDeviceIsPad;

- (UIWindow *)fs_currentSceneKeyWindow;
- (UIViewController *)fs_currentSceneTopMostViewController;
- (UIUserInterfaceSizeClass)fs_currentSceneSizeClass;
- (BOOL)fs_currentSceneHorizontalCompact;
- (BOOL)fs_currentSceneiPadHorizontalCompact;
- (BOOL)fs_currentSceneIsCompact;

#if __has_include(<MBProgressHUD/MBProgressHUD.h>) || __has_include("MBProgressHUD.h")
- (void)fs_toastWithMsg:(NSString *)msg inView:(UIView *)view;
- (void)fs_currentSceneToastWithMsg:(NSString *)msg;
#endif
@end

@interface NSObject (MethodSwizzling)
+ (void)fs_exchangeImpWithOriginalSel:(SEL)originalSel swizzledSel:(SEL)swizzledSel;
+ (void)fs_exchangeImpWithClass:(Class)cls originalSel:(SEL)originalSel swizzledSel:(SEL)swizzledSel;
+ (void)fs_exchangeImpWithOriginalClass:(Class)oriCls swizzledClass:(Class)swiCls originalSel:(SEL)oriSel swizzledSel:(SEL)swiSel tmpSel:(SEL)tmpSel;
@end

IMP ReplaceIMPWithBlock(Class cls, SEL origSEL, id block);
NSString *FSGetObjectPropertyDescription (id obj,  NSString *descriptionString);

NS_ASSUME_NONNULL_END
