/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/
#import <UIKit/UIKit.h>
#if __has_include(<Masonry/Masonry.h>)
    #import <Masonry/Masonry.h>
#else
    #import "Masonry.h"
#endif

NS_ASSUME_NONNULL_BEGIN

@interface UIView (MasonrySafeAreaLayout)

@property (nonatomic, strong, readonly) MASViewAttribute *fs_mas_left;
@property (nonatomic, strong, readonly) MASViewAttribute *fs_mas_right;
@property (nonatomic, strong, readonly) MASViewAttribute *fs_mas_top;
@property (nonatomic, strong, readonly) MASViewAttribute *fs_mas_bottom;

@end

@interface MASConstraint (FSAdd)
- (MASConstraint * (^)(void))fs_equalToSuperview;
- (MASConstraint * (^)(void))fs_greaterThanOrEqualToSuperview;
- (MASConstraint * (^)(void))fs_lessThanOrEqualToSuperview;
- (MAS_VIEW *)fs_superview;
@end

NS_ASSUME_NONNULL_END
