/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

typedef void (^FSAlertActionCallBack)(NSUInteger index, UIAlertAction * _Nonnull action);
typedef void (^FSAlertActionWithTextCallBack)(NSUInteger index, UIAlertAction * _Nonnull action, UITextField * _Nonnull textField);
typedef BOOL (^FSAlertActionEnables)(NSUInteger index, UIAlertAction * _Nonnull action, UITextField * _Nullable textField);
NS_ASSUME_NONNULL_BEGIN

@interface UIAlertController (FSAdd)

+ (UIAlertController *)fs_alertWithTitle:(nullable NSString *)title message:(nullable NSString *)message actions:(NSArray <NSString *>*)actions actionBack:(nullable FSAlertActionCallBack)actionBack;

+ (UIAlertController *)fs_alertWithTitle:(NSString *)title message:(nullable NSString *)message textFieldText:(NSString *)text actions:(NSArray <NSString *>*)actions actionBack:(FSAlertActionWithTextCallBack)actionBack;

+ (UIAlertController *)fs_enablesActionAutomaticallyAlertWithTitle:(nullable NSString *)title message:(NSString *)message textFieldText:(NSString *)text actions:(NSArray <NSString *>*)actions actionBack:(FSAlertActionWithTextCallBack)actionBack;

+ (UIAlertController *)fs_alertWithTitle:(NSString *)title message:(nullable NSString *)message textFieldText:(NSString *)text actions:(NSArray <NSString *>*)actions enablesActionsAutomaticallyIndexs:(nullable NSArray<NSNumber *> *)indexs actionBack:(FSAlertActionWithTextCallBack)actionBack;

+ (void)fs_alertWithTitle:(nullable NSString *)title message:(nullable NSString *)message actions:(NSArray <NSString *>*)actions actionBack:(nullable FSAlertActionCallBack)actionBack onCtrl:(UIViewController *)ctrl;

- (UIAlertController *)fs_actionEnables:(FSAlertActionEnables)actionEnables;

- (void)fs_showByViewController:(UIViewController *)viewController;

@end

NS_ASSUME_NONNULL_END
