/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@interface UIImage (FSAdd)

@property (class, nonatomic, nullable) Class fs_bundleForClass;
@property (class, nonatomic, nullable) NSString *fs_customImageColorSuffix;

+ (UIImage *)fs_imageNamed:(NSString *)name;
+ (UIImage *)fs_imageNamed:(NSString *)name tintColor:(nullable UIColor *)tintColor;
+ (UIImage *)fs_imageNamed:(NSString *)name tintColor:(UIColor *)tintColor customColor:(UIColor *)color;
+ (UIImage *)fs_imageNamed:(NSString *)name tintColor:(UIColor *)tintColor customColors:(NSArray<UIColor *> *)colors;
+ (UIImage *)fs_imageWithColor:(UIColor *)color;
+ (UIImage *)fs_imageWithColor:(UIColor *)color size:(CGSize)size;
+ (UIImage *)fs_imageWithColor:(UIColor *)color font:(UIFont *)font text:(NSString *)text size:(CGSize)size;
+ (UIImage *)fs_dynamicImageWithNormalImage:(UIImage *)normalImage darkImage:(UIImage *)darkImage;
+ (UIImage *)fs_imageDrawRingWithRingW:(CGFloat)ringW borderColor:(UIColor *)color size:(CGSize)size;

//
- (UIImage *)fs_borderWidth:(CGFloat)borderW borderColor:(UIColor *)color;
- (UIImage *)fs_borderWidth:(CGFloat)borderW borderColor:(UIColor *)color cornerRadius:(CGFloat)radius;
- (UIImage *)fs_cornerRadius:(CGFloat)radius;
- (UIImage *)fs_addImage:(UIImage *)image;
- (UIImage *)fs_applyingAlpha:(CGFloat)alpha;
- (UIImage *)fs_imageWithTintColor:(UIColor *)tintColor;
- (UIImage *)fs_imageWithGradientTintColor:(UIColor *)tintColor;
- (UIImage *)fs_imageWithTintColor:(UIColor *)tintColor blendMode:(CGBlendMode)blendMode;
- (UIImage *)fs_adjustScaledBySize:(CGSize)newSize;
- (UIImage *)fs_compressWithMaxLength:(NSUInteger)maxLength;
- (UIImage*)fs_tailoringRect:(CGRect)rect;
- (UIImage *)fs_imageFromCopy;
- (UIImage *)fs_lightImage;
- (UIImage *)fs_darkImage;
- (BOOL)fs_isDynamicImage;
- (UIImage *)fs_fixOrientation;
- (UIImage*)fs_replaceColor:(UIColor*)color withTolerance:(float)tolerance;
- (UIImage *)fs_smoothWithRadius:(CGFloat)radius;
- (UIImage *)fs_sharpenWithSharpness:(CGFloat)sharpness;

+ (UIImage *)fs_imageDrawByBlackColor;
+ (UIImage *)fs_imageDrawByWhiteColor;
+ (UIImage *)fs_imageDrawByRedColor;
+ (UIImage *)fs_imageDrawByGreenColor;
+ (UIImage *)fs_imageDrawByBlueColor;
+ (UIImage *)fs_imageDrawByClearColor;
+ (UIImage *)fs_imageDrawByCenterColor;
@end


NS_ASSUME_NONNULL_END
