/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "UIScrollView+FSAdd.h"

@implementation UIScrollView (FSAdd)

- (CGFloat)fs_offsetX{
    return self.contentOffset.x;
}

- (void)fs_setOffsetX:(CGFloat)x{
    self.contentOffset = CGPointMake(x, self.fs_offsetY);
}

- (CGFloat)fs_offsetY{
    return self.contentOffset.y;
}

- (void)fs_setOffsetY:(CGFloat)y{
    self.contentOffset = CGPointMake(self.fs_offsetX, y);
}

- (void)fs_scrollToTop {
    [self fs_scrollToTopAnimated:YES];
}

- (void)fs_scrollToBottom {
    [self fs_scrollToBottomAnimated:YES];
}

- (void)fs_scrollToLeft {
    [self fs_scrollToLeftAnimated:YES];
}

- (void)fs_scrollToRight {
    [self fs_scrollToRightAnimated:YES];
}

- (void)fs_scrollToTopAnimated:(BOOL)animated {
    CGPoint off = self.contentOffset;
    off.y = 0 - self.contentInset.top;
    [self setContentOffset:off animated:animated];
}

- (void)fs_scrollToBottomAnimated:(BOOL)animated {
    CGPoint off = self.contentOffset;
    off.y = self.contentSize.height - self.bounds.size.height + self.contentInset.bottom;
    [self setContentOffset:off animated:animated];
}

- (void)fs_scrollToLeftAnimated:(BOOL)animated {
    CGPoint off = self.contentOffset;
    off.x = 0 - self.contentInset.left;
    [self setContentOffset:off animated:animated];
}

- (void)fs_scrollToRightAnimated:(BOOL)animated {
    CGPoint off = self.contentOffset;
    off.x = self.contentSize.width - self.bounds.size.width + self.contentInset.right;
    [self setContentOffset:off animated:animated];
}

@end
