/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "UIViewController+FSAdd.h"
#import "NSObject+FSAdd.h"
#import "UIView+FSAdd.h"
#import <objc/runtime.h>
#import "FSMacro.h"

@implementation UIViewController (FSAdd)
YYSYNTH_DYNAMIC_PROPERTY_CTYPE(fs_presentByTopViewController, setFs_presentByTopViewController, BOOL);

- (BOOL)fs_isCurrentViewControllerVisible{
    if ([NSThread isMainThread]) {
        return (self.isViewLoaded && self.view.window);
    }
    __block BOOL ret = NO;
    dispatch_semaphore_t wait = dispatch_semaphore_create(0);
    dispatch_async(dispatch_get_main_queue(), ^{
        ret = (self.isViewLoaded && self.view.window);
        dispatch_semaphore_signal(wait);
    });
    dispatch_semaphore_wait(wait, DISPATCH_TIME_FOREVER);
    return ret;
}

- (UIViewController *)fs_viewWindowRootViewController{
    return self.view.fs_windowRootViewController;
}

@end

