/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import "FSMacro.h"

///------
/// Block
///------

typedef void (^VoidBlock)(void);
typedef BOOL (^BoolBlock)(void);
typedef int  (^IntBlock) (void);
typedef id   (^IDBlock)  (void);

typedef void (^VoidBlock_int)(int);
typedef BOOL (^BoolBlock_int)(int);
typedef int  (^IntBlock_int) (int);
typedef id   (^IDBlock_int)  (int);

typedef void (^VoidBlock_BOOL)(BOOL);
typedef BOOL (^BoolBlock_BOOL)(BOOL);
typedef int  (^IntBlock_BOOL) (BOOL);
typedef id   (^IDBlock_BOOL)  (BOOL);

typedef void (^VoidBlock_string)(NSString *);
typedef BOOL (^BoolBlock_string)(NSString *);
typedef int  (^IntBlock_string) (NSString *);
typedef id   (^IDBlock_string)  (NSString *);

typedef void (^VoidBlock_id)(id);
typedef BOOL (^BoolBlock_id)(id);
typedef int  (^IntBlock_id) (id);
typedef id   (^IDBlock_id)  (id);

///---------------------
/// App Foundation Const
///---------------------

//Duration
FS_EXTERN const FSFLOAT_TYPE ANIMATE_DURATION_NORMAL;
FS_EXTERN const FSFLOAT_TYPE CHANGE_VALUE_BLOCK_INTERVAL;
FS_EXTERN const FSFLOAT_TYPE PROGRESS_TIP_INFO_AFTER_HIDE_DELAY;

//UI alpha
FS_EXTERN const FSFLOAT_TYPE IMAGE_HIGHLIGHTED_ALPHA;
FS_EXTERN const FSFLOAT_TYPE IMAGE_DISABLED_ALPHA;
FS_EXTERN const FSFLOAT_TYPE LABEL_HIGHLIGHTED_ALPHA;
FS_EXTERN const FSFLOAT_TYPE LABEL_DISABLED_ALPHA;

//UI
FS_EXTERN const FSFLOAT_TYPE LAYER_BORDER_WIDTH_6;
FS_EXTERN const FSFLOAT_TYPE LAYER_BORDER_WIDTH_3;
FS_EXTERN const FSFLOAT_TYPE LAYER_BORDER_WIDTH_05;
FS_EXTERN const FSFLOAT_TYPE LAYER_BORDER_WIDTH_1;
FS_EXTERN const FSFLOAT_TYPE LAYER_BORDER_RADIUS_3;

//UI-bar
FS_EXTERN const FSFLOAT_TYPE LANDSCAPE_PREFERENCE_BAR_WIDTH;
FS_EXTERN const FSFLOAT_TYPE IPAD_PREFERENCE_BAR_WIDTH;
FS_EXTERN const FSFLOAT_TYPE STATUS_BAR_HEIGHT_NORMAL;
FS_EXTERN const FSFLOAT_TYPE TAB_BAR_HEIGHT_NORMAL;
FS_EXTERN const FSFLOAT_TYPE TOOL_BAR_HEIGHT_NORMAL;

//UI-item
FS_EXTERN const FSFLOAT_TYPE ITEM_ICON_WIDTH_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_TOP_ICON_MARGIN;
FS_EXTERN const FSFLOAT_TYPE ITEM_MARGIN_SMALL;
FS_EXTERN const FSFLOAT_TYPE ITEM_MARGIN_LITTLE_NORMAL;;
FS_EXTERN const FSFLOAT_TYPE ITEM_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_MARGIN_MEDIUM;
FS_EXTERN const FSFLOAT_TYPE ITEM_LABEL_TOP_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_LABEL_BOTTOM_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_LABEL_TOP_MARGIN_LARGE;
FS_EXTERN const FSFLOAT_TYPE ITEM_LABEL_BOTTOM_MARGIN_LARGE;
FS_EXTERN const FSFLOAT_TYPE ITEM_IMAGE_TOP_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_IMAGE_BOTTOM_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_LEFT_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_RIGHT_MARGIN_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_MEDIUM_SPACE_NORMAL;
FS_EXTERN const FSFLOAT_TYPE ITEM_BOTH_SPACE_NORMAL;

//UI-divide
FS_EXTERN const FSFLOAT_TYPE DIVIDE_TOOL_BAR_THICKNES;
FS_EXTERN const FSFLOAT_TYPE DIVIDE_VIEW_THICKNES;
FS_EXTERN const FSFLOAT_TYPE DIVIDE_PROGRESS_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE DIVIDE_SECTION_HEADER_HEIGHT;

//temporary
FS_EXTERN const FSFLOAT_TYPE VIEW_TEMPORARY_SIZE_VALUE;
FS_EXTERN const FSFLOAT_TYPE TOOLBAR_ITEM_INVALID_MARGIN_VALUE;

//UI-cell
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_GROUPED_PRIMARY_SECTION_HEADER_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_GROUPED_SECONDARY_SECTION_HEADER_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_CELL_ROW_HEIGHT_NORMAL;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_MENU_CELL_ROW_HEIGHT_NORMAL;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_CELL_ROW_HEIGHT_L_LARGER;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_CELL_ROW_HEIGHT_V_LARGER;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_CELL_ROW_HEIGHT_V_V_LAGER;
FS_EXTERN const FSFLOAT_TYPE PREFERENCE_CELL_ROW_HEIGHT_V_V_V_GREAT;

FS_EXTERN const FSFLOAT_TYPE TITLE_LABEL_MIN_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE SUBJECT_LABEL_MIN_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE DESCRIPTION_LABEL_MIN_HEIGHT;

FS_EXTERN const FSFLOAT_TYPE COMMON_RIGHT_ICON_MARGINT;
FS_EXTERN const FSFLOAT_TYPE TITLE_LEFT_ICON_MARGINT;
FS_EXTERN const FSFLOAT_TYPE SUBJECT_LEFT_ICON_MARGINT;
FS_EXTERN const FSFLOAT_TYPE POPOVER_LABEL_LEFT_ICON_MARGINT;

FS_EXTERN const FSFLOAT_TYPE TITLE_LABEL_BOTTOM_MARGINT;
FS_EXTERN const FSFLOAT_TYPE SUBJECT_LABEL_BOTTOM_MARGINT;
FS_EXTERN const FSFLOAT_TYPE DESCRIPTION_LABEL_BOTTOM_MARGINT;

FS_EXTERN const FSFLOAT_TYPE ESTIMATED_HORIZONTAL_HEUGGING_PRIORITY;
FS_EXTERN const FSFLOAT_TYPE ESTIMATED_HORIZONTAL_COMPRESSION_RESISTANCE_PRIORITY;


NS_INLINE CGFloat NAVIGATION_BAR_HEIGHT_NORMAL() {
    if (DEVICE_iPHONE) return 44.f;
    return 48.f;
}

NS_INLINE CGFloat NAVIGATION_HEIGHT_NORMAL() {
    return NAVIGATION_BAR_HEIGHT_NORMAL() + STATUS_BAR_HEIGHT_NORMAL;
}

NS_INLINE CGFloat MIN_BAR_WIDTH_IN_VIEW(UIView *view) {
    CGFloat minW = IPAD_PREFERENCE_BAR_WIDTH - ITEM_MARGIN_NORMAL * 2;
    if (DEVICE_iPHONE) minW = MIN(view.frame.size.width, view.frame.size.height) - ITEM_MARGIN_NORMAL * 2;
    return minW;
}

#define MIN_FOREGROUND_KEY_WINDOW_WIDTH MIN(CGRectGetWidth([NSObject fs_getForegroundAnyKeyWindow].bounds), IPAD_PREFERENCE_BAR_WIDTH)

