/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

#define FSMessageDebounceDefaultOncePerDuration 0.012
#define FSMessageDebouncePerformDefault(task) [FSMessageThrottle debouncePerformTarget:self selector:_cmd oncePerDuration:FSMessageDebounceDefaultOncePerDuration taskBlock:task]
NS_ASSUME_NONNULL_BEGIN

typedef void(^FSThrottleTaskBlock)(void);
@interface FSMessageThrottle : NSObject

+ (void)debouncePerformTarget:(id)target
             selector:(SEL)selector
            oncePerDuration:(NSTimeInterval)durationThreshold
                  taskBlock:(FSThrottleTaskBlock)taskBlock;

+ (void)debouncePerformClass:(Class)cls
             selector:(SEL)selector
            oncePerDuration:(NSTimeInterval)durationThreshold
                  taskBlock:(FSThrottleTaskBlock)taskBlock;

+ (void)debouncePerformIdentity:(NSString *)identity
            oncePerDuration:(NSTimeInterval)durationThreshold
                  taskBlock:(FSThrottleTaskBlock)taskBlock;

@end

NS_ASSUME_NONNULL_END
