/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import <UIKit/UIKit.h>

#define BindThemeKeyPath(TARGET, KEYPATH) \
({ \
    [TARGET fs_bindThemeWithKeyPath:@keypath(TARGET, KEYPATH)]; \
})

#define StateBarThemeKeyPath(TARGET, KEYPATH) \
({ \
    [TARGET fs_stateBarThemeWithKeyPath:@keypath(TARGET, KEYPATH)]; \
})

#define BindThemeKeySel(TARGET, SELECTOR) \
({ \
    [TARGET fs_bindThemeWithKeySel:@keyselector(TARGET, SELECTOR)]; \
})

NS_ASSUME_NONNULL_BEGIN
@class FSCacheForImage;
@interface FSPreferences : NSObject

+ (instancetype)new NS_UNAVAILABLE;
- (instancetype)init NS_UNAVAILABLE;
+ (FSPreferences *)sharePreferences;
@property (nonatomic, assign) BOOL deubgDescriptionLog;

@property (nonatomic, strong, nonnull) UIColor *primaryColor;
@property (nonatomic, strong, nonnull) UIColor *secondaryColor;
@property (nonatomic, strong, nonnull) UIColor *stateBarColor;

@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B1;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B2;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B3;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B4;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B5;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B6;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B7;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B8;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B9;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B10;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B11;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B12;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B13;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B14;
@property (nonatomic, strong, nonnull) UIColor *backgroundColor_B15;

@property (nonatomic, strong, nonnull) UIColor *dividerColor_P1;
@property (nonatomic, strong, nonnull) UIColor *dividerColor_P2;
@property (nonatomic, strong, nonnull) UIColor *dividerColor_P3;
@property (nonatomic, strong, nonnull) UIColor *dividerColor_P4;

@property (nonatomic, strong, nonnull) UIColor *textColor_T1;
@property (nonatomic, strong, nonnull) UIColor *textColor_T2;
@property (nonatomic, strong, nonnull) UIColor *textColor_T3;
@property (nonatomic, strong, nonnull) UIColor *textColor_T4;
@property (nonatomic, strong, nonnull) UIColor *textColor_T5;
@property (nonatomic, strong, nonnull) UIColor *textColor_T6;
@property (nonatomic, strong, nonnull) UIColor *textColor_T7;
@property (nonatomic, strong, nonnull) UIColor *textColor_T8;
@property (nonatomic, strong, nonnull) UIColor *textColor_T9;
@property (nonatomic, strong, nonnull) UIColor *textColor_T10;
@property (nonatomic, strong, nonnull) UIColor *textColor_T11;
@property (nonatomic, strong, nonnull) UIColor *textColor_T12;
@property (nonatomic, strong, nonnull) UIColor *textColor_T13;

@property (nonatomic, strong, nonnull) UIColor *iconColor_I1;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I2;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I3;
@property (nonatomic, strong, nonnull) UIColor *iconDarkColor_I3;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I4;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I5;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I6;
@property (nonatomic, strong, nonnull) UIColor *iconColor_I7;

@property (nonatomic, strong, nonnull) UIColor *linkColor_L1;

@property (nonatomic, strong, nonnull) UIColor *stamp_signautre_color;

@property (nonatomic, strong, nonnull) UIFont *standardImportantFont_IF1;
@property (nonatomic, strong, nonnull) UIFont *standardImportantFont_IF2;
@property (nonatomic, strong, nonnull) UIFont *standardImportantFont_IF3;

@property (nonatomic, strong, nonnull) UIFont *standardGeneralFont_GF1;
@property (nonatomic, strong, nonnull) UIFont *standardGeneralFont_GF2;
@property (nonatomic, strong, nonnull) UIFont *standardGeneralFont_GF3;

@property (nonatomic, strong, nonnull) UIFont *standardWeakFont_WF1;
@property (nonatomic, strong, nonnull) UIFont *standardWeakFont_WF2;
@property (nonatomic, strong, nonnull) UIFont *standardWeakFont_WF3;

@property (nonatomic, strong, nonnull) UIImage *navBarBackIcon;
@property (nonatomic, strong, nonnull) UIImage *navBarCloseIcon;
@property (nonatomic, copy, nonnull) NSString *navBarBackTitle;
@property (nonatomic, assign) UIStatusBarStyle preferredStatusBarStyle;

@property (nonatomic, strong, nullable) FSCacheForImage *imageCache;
@end


typedef void (^UpdateTheme) (id target, SEL sel);
@interface NSObject (Theme)

@property (nonatomic, strong, nonnull, setter=fs_setPrimaryColor:) UIColor *fs_primaryColor;
@property (nonatomic, strong, readonly) UIColor *fs_secondaryColor;
@property (nonatomic, strong,  nonnull, setter=fs_setStateBarColor:) UIColor *fs_stateBarColor;

@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B1;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B2;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B3;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B4;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B5;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B6;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B7;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B8;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B9;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B10;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B11;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B12;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B13;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B14;
@property (nonatomic, strong, readonly) UIColor *fs_backgroundColor_B15;

@property (nonatomic, strong, readonly) UIColor *fs_dividerColor_P1;
@property (nonatomic, strong, readonly) UIColor *fs_dividerColor_P2;
@property (nonatomic, strong, readonly) UIColor *fs_dividerColor_P3;
@property (nonatomic, strong, readonly) UIColor *fs_dividerColor_P4;

@property (nonatomic, strong, readonly) UIColor *fs_textColor_T1;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T2;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T3;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T4;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T5;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T6;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T7;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T8;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T9;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T10;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T11;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T12;
@property (nonatomic, strong, readonly) UIColor *fs_textColor_T13;

@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I1;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I2;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I3;
@property (nonatomic, strong, readonly) UIColor *fs_iconDarkColor_I3;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I4;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I5;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I6;
@property (nonatomic, strong, readonly) UIColor *fs_iconColor_I7;

@property (nonatomic, strong, readonly) UIColor *fs_linkColor_L1;

@property (nonatomic, strong, readonly) UIFont *fs_standardImportantFont_IF1;
@property (nonatomic, strong, readonly) UIFont *fs_standardImportantFont_IF2;
@property (nonatomic, strong, readonly) UIFont *fs_standardImportantFont_IF3;

@property (nonatomic, strong, readonly) UIFont *fs_standardGeneralFont_GF1;
@property (nonatomic, strong, readonly) UIFont *fs_standardGeneralFont_GF2;
@property (nonatomic, strong, readonly) UIFont *fs_standardGeneralFont_GF3;

@property (nonatomic, strong, readonly) UIFont *fs_standardWeakFont_WF1;
@property (nonatomic, strong, readonly) UIFont *fs_standardWeakFont_WF2;
@property (nonatomic, strong, readonly) UIFont *fs_standardWeakFont_WF3;

@property (nonatomic, strong, nonnull, setter=fs_setNavBarBackIcon:) UIImage *fs_navBarBackIcon;
@property (nonatomic, strong, nonnull, setter=fs_setNavBarCloseIcon:) UIImage *fs_navBarCloseIcon;
@property (nonatomic, copy, readonly) NSString *fs_navBarBackTitle;
- (id)fs_bindThemeWithKeyPath:(NSString *)keyPath;
- (void)fs_stateBarThemeWithKeyPath:(NSString *)keyPath;
- (id)fs_bindThemeWithKeySel:(NSString *)keySel;
- (void)fs_cancelBindThemeWithKey:(NSString *)key;
- (void)fs_updateThemeCompleted:(_Nonnull UpdateTheme)completed;

@end

NS_ASSUME_NONNULL_END
