/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSTaskServer.h"

#define LOCK(...) dispatch_semaphore_wait(_lock, DISPATCH_TIME_FOREVER); \
__VA_ARGS__; \
dispatch_semaphore_signal(_lock);

@implementation FSTask

- (instancetype)init {
    self = [super init];
    if (self) {
        self.run = nil;
    }
    return self;
}

@end

@implementation FSTaskServer
{
    dispatch_semaphore_t _lock;
}

- (instancetype)init {
    self = [super init];
    if (self) {
        _lock = dispatch_semaphore_create(1);
    }
    return self;
}

- (id)syncObj {
    return self;
}

- (void)executeSync:(FSTask *)task {
    //LOCK({task.run();});
    task.run();
}

- (void)executeBlockSync:(FSTaskBlock)task {
    //LOCK({task();});
    task();
}

@end
