/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

@interface RedactModule : NSObject <IAnnotPropertyListener, IModule>

/**
 * Get the settrings when adding redact.
 *
 * @return the settrings when adding redact {@link FSReadToolSettings} .
 */
- (FSReadToolSettings *)getToolSettings;

/**
 * Set the settrings when adding redact.
 *
 * @param property the settrings when adding redact {@link FSReadToolSettings} .
 */
- (void)setToolSettings:(FSReadToolSettings *)toolSettings;
 
@end
