/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSURIModule.h"
#import "FSURIAnnotHandler.h"
#import "AudioVideoAnnotHandler.h"
#import "Utility.h"
#import <FoxitRDK/FSPDFViewControl.h>


@interface FSURIModule ()

@end

@implementation FSURIModule{
    FSPDFViewCtrl *__weak _pdfViewCtrl;
    UIExtensionsManager *__weak _extensionsManager;
}

- (NSString *)getName {
    return Module_Uri;
}

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager {
    self = [super init];
    if (self) {
        _extensionsManager = extensionsManager;
        _pdfViewCtrl = extensionsManager.pdfViewCtrl;
//        AudioVideoToolHandler *toolHandler = [[AudioVideoToolHandler alloc] initWithUIExtensionsManager:extensionsManager];
//        [_extensionsManager registerToolHandler:toolHandler];
        FSURIAnnotHandler *annotHandler = [[FSURIAnnotHandler alloc] initWithUIExtensionsManager:extensionsManager];
        [_extensionsManager registerAnnotHandler:annotHandler];
        
        [self loadModule];
    }
    return self;
}

- (void)loadModule {

}

- (void)didClickedReadToolItem:(FSReadToolbarItem *)readToolbarItem {
    
    
}

- (void)dismissAnnotationContinue {
    [Utility dismissAnnotationContinue:_pdfViewCtrl];
}




@end
