/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@class FSTopReplyAnnotationItem;
@interface FSAnnotationItem : NSObject
//
@property (nonatomic, strong, readonly) FSAnnot *annot;

@property (nonatomic, weak, readonly) FSAnnotationItem *replyToAnnotItem;
@property (nonatomic, weak, readonly) FSTopReplyAnnotationItem *topReplyAnnotItem;
@property (nonatomic, assign, readonly) BOOL isTopReply;
@property (nonatomic, assign, readonly) BOOL isReply;
@property (nonatomic, assign, readonly) BOOL annotCanDelete;

@property (nonatomic, weak) NSMutableArray <FSAnnotationItem *>* filterLocPageItmes;
@property (nonatomic, weak) NSMutableArray <FSAnnotationItem *>* locPageItmes;

@property (nonatomic, copy, readonly) NSArray <FSAnnotationItem *>* replies;
//MARK:AllReplies may be equal to replies
@property (nonatomic, copy, readonly) NSArray <FSAnnotationItem *>* allReplies;
@property (nonatomic, weak)UIExtensionsManager* extensionsManager;

@property (nonatomic, assign) BOOL isShowMore;

- (instancetype)initWithAnnot:(FSAnnot *)annot isReply:(BOOL)isReply extensionsManager:(UIExtensionsManager*)extensionsManager;

- (NSString *)getAnnotImageName;

- (void)removeReplyItem:(FSAnnotationItem *)replyItem;

- (void)addReplyItem:(FSAnnotationItem *)replyItem;
@end


@interface FSTopReplyAnnotationItem : FSAnnotationItem
@property (nonatomic, copy, readonly) NSArray <NSString *>* repliesNM;
@property (nonatomic, assign) BOOL unfold;
- (instancetype)initWithAnnot:(FSAnnot *)annot extensionsManager:(UIExtensionsManager*)extensionsManager;
@end

NS_ASSUME_NONNULL_END
