/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "PanelController.h"
#import "FSSearchViewController.h"

@class AnnotationPanel;
@class AnnotationItem;
@class AnnotationButton;
@class UIExtensionsManager;

/** @brief The view controller for annotation list panel. */
@interface FSAnnotationListViewController : FSSearchViewController <IPanelChangedListener, IDocEventListener, IPageEventListener> {
}
@property (nonatomic, assign) BOOL isReflow;

- (id)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager module:(AnnotationPanel *)module;

- (void)clearData;
- (void)resetAnnotationArray;

@end
