/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@interface AudioPlayerControl : NSObject

@property (nonatomic, strong) NSURL *filePath;

- (void)registerEventListens:(UIExtensionsManager*)extensionsMgr;

+ (AudioPlayerControl *)sharedControl;
- (void)addSuperview:(UIView *)view;
- (void)play;
- (void)pause;
- (void)dismiss;
- (void)setNumberOfLoops:(NSInteger)numberOfLoops;
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)new NS_UNAVAILABLE;

@end
