/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */


#import <Foundation/Foundation.h>
#import "FSMediaFileUtil.h"

@class AudioPlayerControl;
@interface AudioVideoModule : NSObject<IAnnotPropertyListener, IReadToolSettingsModule>
@property (nonatomic, strong, readonly) AudioPlayerControl *audioPlay;
@property (nonatomic, assign) FSMediaFileType mediaFileType;
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;

- (void)audioPlayWithFile:(NSURL *)fileURL;
- (void)videoPlayWithFile:(NSURL *)fileURL;

- (void)audioPlayWithFile:(NSURL *)fileURL numberOfLoops:(NSInteger)numberOfLoops;
- (void)videoPlayWithFile:(NSURL *)fileURL numberOfLoops:(NSInteger)numberOfLoops;
@end

