/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

NS_ASSUME_NONNULL_BEGIN

NS_INLINE CGAffineTransform PDFMatrix2DToCGAffine(FSMatrix2D *matrix2D) {
    return CGAffineTransformMake(matrix2D.a, matrix2D.b, matrix2D.c, matrix2D.d, matrix2D.e, matrix2D.f);
}

NS_INLINE FSMatrix2D * CGAffineToPDFMatrix2D(CGAffineTransform transform) {
    return [[FSMatrix2D alloc] initWithA1:transform.a b1:transform.b c1:transform.c d1:transform.d e1:transform.tx f1:transform.ty];
}

NS_INLINE FSRectF * CopyRectF(FSRectF *rectf) {
    return [[FSRectF alloc] initWithLeft1:rectf.left bottom1:rectf.bottom right1:rectf.right top1:rectf.top];
}

NS_INLINE FSMatrix2D * CopyMatrix2D(FSMatrix2D *matrix2D) {
    return [[FSMatrix2D alloc] initWithA1:matrix2D.a b1:matrix2D.b c1:matrix2D.c d1:matrix2D.d e1:matrix2D.e f1:matrix2D.f];
}

NS_INLINE FSPointF * CopyPointF(FSPointF *pointf) {
    return [[FSPointF alloc] initWithX:pointf.x Y:pointf.y];
}

@interface FSPDFDoc (Extensions)
- (FSPDFPage *)getParsedPage:(int)pageIndex;
- (BOOL)isSigned;
- (BOOL)isProtected;
@end

NS_ASSUME_NONNULL_END
