/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPDFObject+Extensions.h"

@implementation FSPDFObject (Extensions)
- (__kindof FSPDFObject *)rdk_getPDFObject{
    switch ([self getType]) {
        case FSPDFObjectArray:
            return [self getArray];
        case FSPDFObjectDictionary:
            return [self getDict];
        case FSPDFObjectReference:{
            FSPDFObject *pdfDirectObject = [self getDirectObject];
            return [pdfDirectObject rdk_getPDFObject];
        }
        default:
            return self;
    }
    return self;
}
@end

@implementation FSPDFDictionary (Extensions)
- (__kindof FSPDFObject *)rdk_getElement:(NSString *)key{
    return [[self getElement:key] rdk_getPDFObject];
}
@end

@implementation FSPDFArray (Extensions)
- (__kindof FSPDFObject *)rdk_getElement:(int)index{
    return [[self getElement:index] rdk_getPDFObject];
}
@end

