/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "UIAlertController+Extensions.h"
#import "UIViewController+FSAdd.h"

@implementation UIAlertController (Extensions)

+ (void)fs_alert_OK_WithTitle:(NSString *)title message:(NSString *)message onCtrl:(UIViewController *)ctrl{
    [self fs_alert_OK_WithTitle:title message:message actionBack:nil onCtrl:ctrl];
}

+ (void)fs_alert_OK_WithTitle:(nullable NSString *)title message:(nullable NSString *)message actionBack:(nullable FSAlertActionCallBack)actionBack onCurrentSceneResponder:(__kindof UIResponder *)responder{
    [self fs_alert_OK_WithTitle:title message:message actionBack:actionBack onCtrl:[responder fs_currentSceneTopMostViewController]];
}

+ (void)fs_alert_OK_WithTitle:(NSString *)title message:(NSString *)message actionBack:(FSAlertActionCallBack)actionBack onCtrl:(UIViewController *)ctrl{
    if ([title hasPrefix:@"k"]) title = FSLocalizedForKey(title);
    if ([message hasPrefix:@"k"]) message = FSLocalizedForKey(message);
    if (!ctrl.fs_isCurrentViewControllerVisible) {
        [ctrl.view fs_showHUDMessage:message];
        return;
    }
    UIAlertController *alertCtrl = [self fs_alertWithTitle:title message:message actions:@[ FSLocalizedForKey(@"kOK")] actionBack:actionBack];
    [ctrl presentViewController:alertCtrl animated:YES completion:nil];
}

@end
