/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSSummarizeCommentsViewController.h"

@interface FSSummarizeCommentsViewController ()<IRotationEventListener>

@end

@implementation FSSummarizeCommentsViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.title = FSLocalizedForKey(@"kSummarizeComments");
    self.navBarLeftTitle = FSLocalizedForKey(@"kClose");
}


-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 2;
}

- (__kindof UITableViewCell *)tableView:(UITableView *)tableView dequeueReusableCellWithIdentifier:(NSString *)identifier forIndexPath:(NSIndexPath *)indexPath withDataItem:(nullable id)dataItem{

    identifier = NSStringFromClass([FSTitleEstimatedTableViewCell class]);

    return  [super tableView:tableView dequeueReusableCellWithIdentifier:identifier forIndexPath:indexPath withDataItem:dataItem];
}

- (void)configureCell:(FSTitleEstimatedTableViewCell *)cell atIndexPath:(NSIndexPath *)indexPath withDataItem:(id)dataItem{
    
    cell.selectedBackgroundColor = self.fs_dividerColor_P1;
    cell.contentView.backgroundColor = nil;
    if (indexPath.row == 0) {
        cell.estimatedTitleLabel.text = FSLocalizedForKey(@"kDocumentAndComments");
    }else if (indexPath.row == 1){
        cell.estimatedTitleLabel.text = FSLocalizedForKey(@"kCommentsOnly");
    }
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    dispatch_async(dispatch_get_main_queue(), ^{
        
        [self dismissViewControllerAnimated:YES completion:^{
            SummarizeType summarizeType = SummarizeTypeUnknow;
            if (indexPath.row == 0) {
                summarizeType = SummarizeTypeDocumentAndComments;
            }else if (indexPath.row == 1){
                summarizeType = SummarizeTypeCommentsOnly;
            }
            if (self.summarizeBlock) {
                self.summarizeBlock(summarizeType);
            }
        }];

    });
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

-(BOOL)emptyDataSetShouldDisplay:(UITableView *)tableView{
    return NO;
}

@end
