/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSAppInfoProvider.h"


@implementation FSAppInfoProvider


- (NSString *)getAppName{
    NSDictionary *metadata = [[NSBundle mainBundle] infoDictionary];
    NSString *appName = metadata[@"CFBundleDisplayName"];
    if (!appName)
    {
        appName = metadata[@"CFBundleName"];
    }
    return appName;
    
}


- (NSString *)getAppVersion{
    NSString *appVersion = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    if (!appVersion)
    {
        appVersion = @"Unknown";
    }
    return appVersion;
}

- (NSString *)getUserName{
    return @"";
}
@end
