/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import "FSBaseViews.h"
#import "PrivateDefine.h"

@implementation FSView

- (instancetype)init{
    self = [super init];
    if (self) {
        [self setup];
    }
    
    return self;
}

- (void)setup{
    self.backgroundColor = ThemeViewBackgroundColor;
}

- (void)awakeFromNib{
    [super awakeFromNib];
    [self setup];
}

@end

@implementation FSCellView

- (instancetype)init{
    self = [super init];
    if (self) {
        [self setup];
    }
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        [self setup];
    }
    return self;
}

- (void)setup{
    self.backgroundColor = ThemeCellBackgroundColor;
}

- (void)awakeFromNib{
    [super awakeFromNib];
    [self setup];
}

@end

@implementation FSLineIconView

- (void)awakeFromNib{
    [super awakeFromNib];
    self.backgroundColor = ThemePopViewDividingLineColor;
}

@end

@implementation FSSwitch


- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        [self setup];
    }
    return self;
}

- (void)setup{
    self.onTintColor = SwitchOnColor;
}

- (void)awakeFromNib{
    [super awakeFromNib];
    [self setup];
}

@end

@implementation FSLabel

- (void)awakeFromNib{
    [super awakeFromNib];
    self.textColor = BlackThemeTextColor;
}

@end

@implementation FSButton

- (void)awakeFromNib{
    [super awakeFromNib];
}

@end



