/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSEasyDoneTextView.h"

@implementation FSEasyDoneTextView

- (FSItem *)doneItem{
    if(!_doneItem){
        _doneItem = [FSItem new];
        [BindThemeKeySel(_doneItem, setImage:forState:) fs_updateThemeCompleted:^(FSItem * _Nonnull target, SEL  _Nonnull sel) {
            [target setImage:FSImageNamedAndPrimaryColor(@"common_input_view_done") forState:UIControlStateNormal];
        }];
        
        FSToolbar *doneToolbar = [[FSToolbar alloc] initWithStyle:FSToolbarStyleDefault];
        doneToolbar.backgroundColor = [UIColor clearColor];
        doneToolbar.fs_height = TOOL_BAR_HEIGHT_NORMAL;
        [doneToolbar addItem:_doneItem spacing:4.f  atPosition:FSItemPositionRight];
        self.inputAccessoryView = doneToolbar;
    }
    return _doneItem;
}
@end
