/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef FSMenuViewManager_Private_h
#define FSMenuViewManager_Private_h


#import "FSMenuViewManager.h"

@interface FSMenuItem ()
@property (nonatomic, weak) id target;
@property (nonatomic, assign) SEL selAction;
@property (nonatomic, assign) NSInteger actionTag;
- (instancetype)initWithTitle:(NSString *)title image:(UIImage *)image actionTag:(NSInteger)tag;
- (instancetype)initWithMenuItem:(MenuItem*)menuItem;
@end

@interface FSMenuViewManager ()
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
@end

#endif /* FSMenuViewManager_Private_h */
