/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPDFDocDatasModel.h"

static NSMapTable *_docMapDataTable;

@interface FSPDFDocDatasModel ()
@property (nonatomic, copy) NSString *flag;
@end
@implementation FSPDFDocDatasModel

+ (void)initialize{
    [super initialize];
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _docMapDataTable = [[NSMapTable alloc] initWithKeyOptions:NSPointerFunctionsWeakMemory valueOptions:NSPointerFunctionsWeakMemory capacity:20];
    });
}

- (instancetype)initWithDoc:(FSPDFDoc *)doc {
    return [self initWithDoc:doc flag:NSStringFromClass([self class])];
}

- (instancetype)initWithDoc:(FSPDFDoc *)doc flag:(NSString *)flag{
    FSPDFDocDatasModel *data = [_docMapDataTable valueForKey:[NSString stringWithFormat:@"%@%p",flag,[doc getCptr]]];
    if (data) return data;
    self = [super init];
    if(self){
        _flag = flag;
        _pdfDoc = doc;
        [self initialize];
        [_docMapDataTable setValue:self forKey:[NSString stringWithFormat:@"%@%p",flag,[doc getCptr]]];
    }
    return self;
}

- (void)initialize{}

- (BOOL)isEqual:(FSPDFDocDatasModel *)object{
    if (!object || [object isMemberOfClass:self.class]) {
        return NO;
    }
    return self.flag.hash == object.flag.hash && [self.pdfDoc isEqual:object.pdfDoc];
}

- (NSUInteger)hash{
    return self.flag.hash ^ (NSUInteger)[self.pdfDoc getCptr];
}

@end

@implementation FSUIExtensionsData

//- (NSMutableArray<UndoItem *> *)undoItems{
//    if(!_undoItems){
//        _undoItems = [NSMutableArray array];
//    }
//    return _undoItems;
//}
//
//- (NSMutableArray<UndoItem *> *)redoItems{
//    if(!_redoItems){
//        _redoItems = [NSMutableArray array];
//    }
//    return _redoItems;
//}
//
//- (NSMutableArray<IFSUndoEventListener> *)undoListeners{
//    if(!_undoListeners){
//        _undoListeners = [NSMutableArray<IFSUndoEventListener> array];
//    }
//    return _undoListeners;
//}

@end
