/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPDFViewCtrlContainerView.h"

@interface FSPDFViewCtrlContainerView ()
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@end

@implementation FSPDFViewCtrlContainerView

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (instancetype)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager{
    self = [super init];
    if (self) {
        self.backgroundColor = [UIColor colorWithWhite:0 alpha:0];
        _extensionsManager = extensionsManager;
        
        [_extensionsManager.pdfViewCtrl addSubview:self];
        [self mas_remakeConstraints:^(MASConstraintMaker *make) {
            make.left.right.top.bottom.fs_equalToSuperview();
        }];
    }
    return self;
}

- (UIView *)hitTest:(CGPoint)point withEvent:(UIEvent *)event{
    UIView *view = [super hitTest:point withEvent:event];
    if (view == self) {
        return nil;
    }
    if ([view isDescendantOfView:[_extensionsManager.topToolbar getToolbarContentView]] ||
        [view isDescendantOfView:[_extensionsManager.topToolbar subMenuTopbarContentView]] ||
        [view isDescendantOfView:[_extensionsManager.bottomToolbar getToolbarContentView]] ) {
        if (event) {
            [_extensionsManager delayHideTopBottomToolBar];
        }
    }
    return view;
}

@end
