/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/
#import "FSUtilities.h"

FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH;
FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGR_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH_EX;
FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGE_HEIGHT_EX;
FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH_LARGE_EX;
FS_EXTERN const FSFLOAT_TYPE THUMBNAIL_IMAGE_HEIGHT_LARGE_EX;
FS_EXTERN const FSFLOAT_TYPE FILE_IMAGE_WIDTH;
FS_EXTERN const FSFLOAT_TYPE FILE_IMAGE_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE OVERVIEW_IMAGE_WIDTH;
FS_EXTERN const FSFLOAT_TYPE OVERVIEW_IMAGE_HEIGHT;
FS_EXTERN const FSFLOAT_TYPE OVERVIEW_IMAGE_WIDTH_IPHONE;
FS_EXTERN const FSFLOAT_TYPE OVERVIEW_IMAGE_HEIGHT_IPHONE;

FS_EXTERN const FSFLOAT_TYPE NOTE_ANNOTATION_WIDTH;
FS_EXTERN const FSFLOAT_TYPE RECT_INSET;


FS_EXTERN const FSAnnotType FSAnnotImage;
FS_EXTERN const FSAnnotType FSAnnotAudio;
FS_EXTERN const FSAnnotType FSAnnotVideo;
FS_EXTERN const FSAnnotType FSAnnotAreaHighlight;
FS_EXTERN const FSAnnotType FSAnnotURI;
FS_EXTERN const FSAnnotType FSAnnotReflow;

FS_EXTERN FSToolStringName const Tool_Password;         ///< name of password tool

FS_EXTERN FSModuleStringName const Module_Audio_Video;
FS_EXTERN FSModuleStringName const Module_Fill_Sign;            ///< name of fill and sign module
FS_EXTERN FSModuleStringName const Module_Thumbnail;            ///< name of thumbnail module
FS_EXTERN FSModuleStringName const Module_Multiple_Selection;   ///< name of multiple selection module
FS_EXTERN FSModuleStringName const Module_Uri;                  ///< name of uri module
FS_EXTERN FSModuleStringName const Module_Redaction;
FS_EXTERN FSModuleStringName const Module_Password;

/** Define notification center observer messages for annotation events. */
typedef NSNotificationName FSNotificationName;

FS_EXTERN FSNotificationName const FSAnnotListUpdateTotalNotification;
FS_EXTERN FSNotificationName const FSDeviceOrientationChangeNotification;
FS_EXTERN FSNotificationName const FSApplicationHandleOpenURLNotification;
FS_EXTERN FSNotificationName const FSBookmarkUpdateNotification;
FS_EXTERN FSNotificationName const NSNotificationNameFlattenDoc;
FS_EXTERN FSNotificationName const FSNotificationNameFlattenAnnot;
FS_EXTERN FSNotificationName const FSNotificationNameSomeDocFileInfoVCState;
FS_EXTERN FSNotificationName const FSNotificationNameSomeReloadCustomStamps;

typedef NS_ENUM(NSUInteger, FSAnnotationOperation) {
    FSAnnotationOperationAdd = 1,
    FSAnnotationOperationDelete,
    FSAnnotationOperationModify
};

#ifndef FS_UIEXTENSIONS_VERSION
#define FS_UIEXTENSIONS_VERSION [[[NSBundle bundleForClass:[self class]] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
#endif


#import "FSCacheForImage.h"

#define DATA_FOLDER_NAME @"Data"
#define INTERNAL_FOLDER_NAME @"Internal"
#define UNDO_CACHE_FOLDER_NAME @"UndoCache"
#define SIGNATURE_FOLDER_NAME @"Signature"
#define CUSTOM_TEXT_STAMP_FOLDER_NAME @"CustomStamp/Text"
#define CUSTOM_IMAGE_STAMP_FOLDER_NAME @"CustomStamp/Image"

#define DATA_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(LIBRARY_PATH, DATA_FOLDER_NAME)
#define INTERNAL_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(DATA_PATH, INTERNAL_FOLDER_NAME)
#define UNDO_CACHE_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(INTERNAL_PATH, UNDO_CACHE_FOLDER_NAME)
#define SIGNATURE_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(DATA_PATH, SIGNATURE_FOLDER_NAME)
#define CUSTOM_TEXT_STAMP_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(DATA_PATH, CUSTOM_TEXT_STAMP_FOLDER_NAME)
#define CUSTOM_IMAGE_STAMP_PATH CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(DATA_PATH, CUSTOM_IMAGE_STAMP_FOLDER_NAME)
#define TOPBAR_PAGESLIDER_TAG 1001

