/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH = 58.f;
const FSFLOAT_TYPE THUMBNAIL_IMAGR_HEIGHT = 58.f;
const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH_EX = 84.f;
const FSFLOAT_TYPE THUMBNAIL_IMAGE_HEIGHT_EX = 87.f;
const FSFLOAT_TYPE THUMBNAIL_IMAGE_WIDTH_LARGE_EX = 128.f;
const FSFLOAT_TYPE THUMBNAIL_IMAGE_HEIGHT_LARGE_EX = 134.f;
const FSFLOAT_TYPE FILE_IMAGE_WIDTH = 50.f;
const FSFLOAT_TYPE FILE_IMAGE_HEIGHT = 54.f;
const FSFLOAT_TYPE OVERVIEW_IMAGE_WIDTH = 160.f;
const FSFLOAT_TYPE OVERVIEW_IMAGE_HEIGHT = 200.f;
const FSFLOAT_TYPE OVERVIEW_IMAGE_WIDTH_IPHONE = 142.f;
const FSFLOAT_TYPE OVERVIEW_IMAGE_HEIGHT_IPHONE = 177.f;

const FSFLOAT_TYPE NOTE_ANNOTATION_WIDTH = 20.f;
const FSFLOAT_TYPE RECT_INSET = -15.f;

const FSAnnotType FSAnnotArrowLine = 99;
const FSAnnotType FSAnnotInsert = 101;
const FSAnnotType FSAnnotTextbox = 103;
const FSAnnotType FSAnnotCloud = 105;
const FSAnnotType FSAnnotCallout = 107;
const FSAnnotType FSAnnotDistance = 109;
const FSAnnotType FSAnnotReplace = 110;

const FSAnnotType FSAnnotImage = 111;
const FSAnnotType FSAnnotAudio = 112;
const FSAnnotType FSAnnotVideo = 113;
const FSAnnotType FSAnnotAreaHighlight = 114;
const FSAnnotType FSAnnotURI = 115;
const FSAnnotType FSAnnotReflow = 116;

FSToolStringName const Tool_Select = @"Select";
FSToolStringName const Tool_Note = @"Note";
FSToolStringName const Tool_Freetext = @"Freetext";
FSToolStringName const Tool_Textbox = @"Textbox" ;
FSToolStringName const Tool_Callout = @"Callout" ;
FSToolStringName const Tool_Pencil = @"Pencil";
FSToolStringName const Tool_Eraser = @"Eraser";
FSToolStringName const Tool_Stamp = @"Stamp";
FSToolStringName const Tool_Insert = @"Insert";
FSToolStringName const Tool_Replace = @"Replace" ;
FSToolStringName const Tool_Attachment = @"Attachment";
FSToolStringName const Tool_Signature = @"Signature";
FSToolStringName const Tool_Line = @"Line";
FSToolStringName const Tool_Arrow = @"Arrow";
FSToolStringName const Tool_Markup = @"Markup";
FSToolStringName const Tool_Highlight = @"Highlight";
FSToolStringName const Tool_Squiggly = @"Squiggly";
FSToolStringName const Tool_Strikeout = @"Strikeout";
FSToolStringName const Tool_Underline = @"Underline";
FSToolStringName const Tool_Shape = @"Shape";
FSToolStringName const Tool_Rectangle = @"Rectangle";
FSToolStringName const Tool_Oval = @"Oval";
FSToolStringName const Tool_Distance = @"Distance";
FSToolStringName const Tool_Image = @"Image";
FSToolStringName const Tool_Polygon = @"Polygon" ;
FSToolStringName const Tool_Cloud = @"Cloud";
FSToolStringName const Tool_PolyLine = @"PolyLine";
FSToolStringName const Tool_Audio = @"Audio";
FSToolStringName const Tool_Video = @"Video";
FSToolStringName const Tool_Link = @"Link";
FSToolStringName const Tool_Multiple_Selection = @"MultipleSelection";
FSToolStringName const Tool_Redaction = @"Redaction" ;
FSToolStringName const Tool_Form = @"Form";
FSToolStringName const Tool_Fill_Sign = @"FillSign";
FSToolStringName const Tool_Password = @"Password";

FSModuleStringName const Module_Audio_Video = @"AudioVideo";
FSModuleStringName const Module_Fill_Sign = Tool_Fill_Sign;
FSModuleStringName const Module_Signature = Tool_Signature;
FSModuleStringName const Module_Thumbnail = @"Thumbnail";
FSModuleStringName const Module_Multiple_Selection = @"MultipleSelection";
FSModuleStringName const Module_Speech = @"Speech";
FSModuleStringName const Module_Uri = @"URI";
FSModuleStringName const Module_History_Data = @"History_Data";
FSModuleStringName const Module_Redaction = @"Redact";
FSModuleStringName const Module_Password = Tool_Password;


FSNotificationName const FSAnnotListUpdateTotalNotification = @"FSAnnotListUpdateTotalNotification";
FSNotificationName const FSDeviceOrientationChangeNotification = @"FSDeviceOrientationChangeNotification";
FSNotificationName const FSApplicationHandleOpenURLNotification = @"FSApplicationHandleOpenURLNotification";
FSNotificationName const FSBookmarkUpdateNotification = @"FSBookmarkUpdateNotification";
FSNotificationName const NSNotificationNameFlattenDoc = @"NSNotificationNameFlattenDoc";
FSNotificationName const FSNotificationNameFlattenAnnot = @"FSNotificationNameFlattenAnnot";
FSNotificationName const FSNotificationNameSomeReloadCustomStamps = @"FSNotificationNameSomeReloadCustomStamps";


/**@brief Defines existing-supplied images  for main tool bar items..*/
//The back item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_BACK = 100;
//The more item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_MORE = 101;
//The search item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_SEARCH = 102;
//The panel item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_PANEL = 103;
//The view settings item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_VIEW_SETTINGS = 104;
//The Thumbnai item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_THUMBNAIL = 105;
//The bookmark item
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_READING_BOOKMARK = 106;
///The home tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_HOME = 107;
///The edit tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_EDIT = 108;
///The comment tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_COMMENT = 109;
///The drawing tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_DRAWING = 110;
///The view tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_VIEW = 111;
///The form tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_FORM = 112;
///The sign tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_SIGN = 113;
///The protect tag
const FS_TOOLBAR_ITEM_TAG FS_TOOLBAR_ITEM_TAG_PROTECT = 114;
