/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

typedef NSString *FSPreferenceModuleName;

FS_EXTERN FSPreferenceModuleName const FSPreferenceModuleNameSignature;
FS_EXTERN FSPreferenceModuleName const FSPreferenceModuleToolbarSettings;
FS_EXTERN FSPreferenceModuleName const FSPreferenceModuleSpeech;

#import <Foundation/Foundation.h>

/** @brief Utility class for user preference. */
@interface Preference : NSObject

+ (int)getIntValue:(NSString *)module type:(NSString *)type defaultValue:(int)defVal;
+ (void)setIntValue:(NSString *)module type:(NSString *)type value:(int)value;
+ (float)getFloatValue:(NSString *)module type:(NSString *)type defaultValue:(float)defVal;
+ (void)setFloatValue:(NSString *)module type:(NSString *)type value:(float)value;
+ (BOOL)getBoolValue:(FSPreferenceModuleName)module type:(NSString *)type delaultValue:(BOOL)defVal;
+ (void)setBoolValue:(NSString *)module type:(NSString *)type value:(BOOL)value;
+ (NSString *)getStringValue:(FSPreferenceModuleName)module type:(NSString *)type delaultValue:(NSString *)defVal;
+ (void)setStringValue:(FSPreferenceModuleName)module type:(NSString *)type value:(NSString *)value;
@end
