/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@protocol IFSUIExtensionsModifiedEventListener <NSObject>
- (void)extensions:(UIExtensionsManager *)extensions modifiedEventDealSel:(SEL)sel args:(NSArray *)args;
@end
@class UIExtensionsModifiedContext;
@interface UIExtensionsManager (SupportsMultipleScenes_Private)
@property (nonatomic, strong, readonly) UIExtensionsModifiedContext *modifiedContext;
+ (void)addExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)updateCallbackSubstitute;
- (void)adapterMultipleScenes;
- (BOOL)shouldSyncOtherScenes;
- (NSArray <UIExtensionsManager *> *)someDocFromOtherScenes;
- (void)supportsMultipleScenesOp:(void(^)(UIExtensionsManager *self))op;
- (void)supportsMultipleScenesOp:(void(^)(UIExtensionsManager *self, id))op obj:(id)obj;
- (void)supportsMultipleScenesOp:(void(^)(UIExtensionsManager *self, id, id))op obj1:(id)obj1 obj2:(id)obj2;
- (void)registerExtensionsModifiedEventListener:(id<IFSUIExtensionsModifiedEventListener>)listener;
- (void)unregisterExtensionsModifiedEventListener:(id<IFSUIExtensionsModifiedEventListener>)listener;
- (void)onDocOpenedSupportsMultiplehook;
- (void)onDocWillCloseSupportsMultiplehook;
- (void)onDocClosedSupportsMultiplehook;
@end


NS_ASSUME_NONNULL_END
