/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSCompareFileSelectViewController.h"
#import "FileItem.h"


@interface FSFileSelectDestinationViewController ()

@property (nonatomic, assign) int MultiSelectLimit;
@property (nonatomic, strong) NSMutableArray *multiSelectedFilesArr;
@property (nonatomic, strong) NSMutableDictionary *multiSelectedIndexPathsDict;
@property (nonatomic, strong) NSMutableArray *multiSelectedIndexPathsArr;
@property (nonatomic, strong) NSString* currentSelectedFolderName;

@end

@interface FSCompareFileSelectViewController ()
@end

@implementation FSCompareFileSelectViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.passwordDict = [NSMutableDictionary dictionary];
}

- (void)initNavigationBar {
    [super initNavigationBar];
    FSItem *doneItem = self.navBar.rightItem;
    doneItem.accessibilityLabel = FSLocalizedForKey(@"kComparisonVCTitle");
    if (self.doneBtnImage) {
        [doneItem setImage:self.doneBtnImage forState:UIControlStateNormal];
        [doneItem setTitle:@"" forState:UIControlStateNormal];
    }
    
//    FSItem *leftItem = self.navBar.leftItem;
//    [leftItem setTitleColor:self.fs_textColor_T1 forState:UIControlStateNormal];
//    [BindThemeKeySel(leftItem, setTitleColor:forState:) fs_updateThemeCompleted:^(FSItem *  _Nonnull target, SEL  _Nonnull sel) {
//
//    }];
//    
//    self.navBar.backgroundColor = [FSPreferences sharePreferences].primaryColor;
//    BindThemeKeyPath(self.navBar, backgroundColor);
//    
//    [self.navBar.titleItem setTitleColor:self.fs_textColor_T1 forState:UIControlStateNormal];
}

- (void)setSelectedDataSource:(NSArray *)selectedDataSource{
    [super setSelectedDataSource:selectedDataSource];
    self.doneItem.enabled = selectedDataSource.count == 2;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    FileItem *fileItem = [self dataForAtIndexPath:indexPath];
    if (fileItem.isFolder){
        [tableView deselectRowAtIndexPath:indexPath animated:YES];
        
        FSCompareFileSelectViewController *selectDestination = [[FSCompareFileSelectViewController alloc] initWithServices:self.services];
        selectDestination.fileSelectDestinationType = self.fileSelectDestinationType;
        selectDestination.fileSelectSpecialActionType = self.fileSelectSpecialActionType;
        selectDestination.operatingHandler = self.operatingHandler;
        selectDestination.isRootFileDirectory = NO;
        selectDestination.exceptFolderList = self.exceptFolderList;
        selectDestination.expectFileType = self.expectFileType;
        selectDestination.currentSelectedFolderName = fileItem.title;
        selectDestination.titleForTypeSelectFolder = self.titleForTypeSelectFolder;
        [selectDestination setFileMultiSelectLimit:2];
        selectDestination.isClosedWhenDone = NO;
        selectDestination.doneBtnImage = FSImageNamed(@"document_compare");
        
        if (self.fileSelectSpecialActionType == FSFileSelectSpecialActionTypeMultiple) {

            selectDestination.multiSelectDoneHandler = self.multiSelectDoneHandler;
            [selectDestination setFileMultiSelectLimit:2];
            selectDestination.multiSelectedFilesArr = self.multiSelectedFilesArr;
            selectDestination.multiSelectedIndexPathsDict = self.multiSelectedIndexPathsDict;
        }
        [selectDestination loadFilesWithPath:fileItem.filekey];
        [self.services pushViewController:selectDestination animated:YES];
    }else{
        [super tableView:tableView didSelectRowAtIndexPath:indexPath];
    }
    
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
