/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>
#import "FSTableViewController.h"

typedef NS_ENUM(NSUInteger, FSFileSelectSpecialActionType) {
    FSFileSelectSpecialActionTypeNone,
    FSFileSelectSpecialActionTypeSingle,
    FSFileSelectSpecialActionTypeMultiple,
    FSFileSelectSpecialActionTypeImport = FSFileSelectSpecialActionTypeSingle,
    FSFileSelectSpecialActionTypeAdd = FSFileSelectSpecialActionTypeMultiple,
};

typedef NS_ENUM(NSUInteger, FSFileSelectDestinationType) {
    FSFileSelectDestinationTypeSelectFile,
    FSFileSelectDestinationTypeSelectFolder,
};

@class FSFileSelectDestinationViewController;
typedef void (^FSFileDoneHandler)(FSFileSelectDestinationViewController *controller, NSArray *destinationFolder);
typedef void (^FSFileCallOffHandler)(FSFileSelectDestinationViewController *controller);
typedef void (^FSFileMultiSelectDoneHandler)(FSFileSelectDestinationViewController *controller, NSArray *destinationFolder,NSMutableDictionary *passwordDict);

@interface FSFileSelectDestinationViewController : FSTableViewController <UITableViewDataSource, UITableViewDelegate, UINavigationControllerDelegate>

@property (strong, nonatomic) NSArray *exceptFolderList;
@property (nonatomic, strong) NSArray *expectFileType;
@property (nonatomic, strong) NSMutableArray *fileItemsArray;
@property (nonatomic, assign) BOOL isRootFileDirectory;
@property (nonatomic, strong) NSString *titleForTypeSelectFolder;
@property (copy, nonatomic) FSFileDoneHandler operatingHandler;
@property (copy, nonatomic) FSFileCallOffHandler cancelHandler;
@property (nonatomic, strong) FSItem *doneItem;
@property (copy, nonatomic) FSFileMultiSelectDoneHandler multiSelectDoneHandler;
@property (nonatomic, assign) BOOL isClosedWhenDone;
@property (nonatomic, assign) FSFileSelectDestinationType fileSelectDestinationType;
@property (nonatomic, assign) FSFileSelectSpecialActionType fileSelectSpecialActionType;

- (void)loadFilesWithPath:(NSString *)filePath;
- (void)setFileMultiSelectLimit:(int)limit;
- (void)initNavigationBar;
@end
