/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSCollectionViewController.h"
#import "FSThumbnailViewController.h"

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FSThumbnailChildType) {
    FSThumbnailChildTypeAll = 0,
    FSThumbnailChildTypeAnnoted,
    FSThumbnailChildTypeBookmark,
};

@interface FSThumbnailChildViewController : FSCollectionViewController
@property (nonatomic, readonly) BOOL needPasteItem;
@property (nonatomic, readonly) NSInteger insertIndex;
@property (nonatomic, strong, readonly) FSPDFDoc *copyedDoc;

@property (nonatomic, strong, readonly) NSMutableArray *annotedPageIndexs;
@property (nonatomic, weak) NSMutableArray *bookmarkPageIndexs;
@property (nonatomic, weak) FSThumbnailViewController *thumbnailParentViewController;

@property (nonatomic, assign, readonly) FSThumbnailChildType thumbnailChildType;

@property (nonatomic, assign) BOOL isEditing;

- (void)selectOrDeselectAll;

- (NSUInteger)getNumberOfItemsInCollectionView;

- (int)getPageIndexInCollectionViewAtItem:(NSInteger)item;

- (void)cancelDrawingThumbnails;

- (void)cancelDrawingThumbnailsAtIndexPaths:(NSArray<NSIndexPath *> *)indexPaths ;

- (void)insertPagesInIndexPaths:(NSArray<NSIndexPath *> *)indexPaths atIndex:(NSUInteger)index;

- (void)insertCopyItem;

- (void)deleteCopyItem;

- (NSArray <NSNumber *> *)getSelectedItemsForOrderedAscending;

- (void)willDeletePageIndexs:(NSArray <NSNumber *> *)pageIndexs;
- (void)didDeletePageIndexs:(NSArray <NSNumber *> *)pageIndexs;
- (void)movePageIndexsAfterReload;
- (FSPDFDoc *)getDocForSelectedPageIndexs;
- (void)copyDocForSelectedPageIndexs;
@end

NS_ASSUME_NONNULL_END
