/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSUndo.h"

NS_ASSUME_NONNULL_BEGIN

@interface FSFillSignObjAttributes : NSObject
@property (nonatomic, assign) CGRect rect;
@property (nonatomic, assign) FSFillSignFillSignObjectType type;
@property (nonatomic) BOOL isTextFillSign;
+ (instancetype)attributesWithFillSignObject:(FSFillSignObject *)fillSignObject;
- (instancetype)initWithFillSignObject:(FSFillSignObject *)fillSignObject;
- (void)resetFillSignObject:(FSFillSignObject *)fillSignObject;
- (BOOL)isEqualToAttributes:(FSFillSignObjAttributes *)attributes;

@end
@interface FSTextFillSignObjAttributes : FSFillSignObjAttributes
@property (nonatomic) BOOL isSegText;
@property (nonatomic, strong) FSTextFillSignObjectDataArray *textDataArray;
@end

@interface FSFillSignUndoItem : UndoItem
@property (nonatomic, strong) FSFillSignObjAttributes *fillSignObjAttributes;
@property (nonatomic, strong) FSFillSignObjAttributes *oldFillSignObjAttributes;
@property (nonatomic) void *formXObjCptr;


+ (instancetype)itemForUndoModifyFillSignWithExtensionsManager:(UIExtensionsManager *)extensionsManager page:(FSPDFPage *)page;
+ (instancetype)itemForUndoAddFillSignWithExtensionsManager:(UIExtensionsManager *)extensionsManager page:(FSPDFPage *)page;
+ (instancetype)itemForUndoDeleteFillSignWithExtensionsManager:(UIExtensionsManager *)extensionsManager page:(FSPDFPage *)page;

- (void)restoreFormXObjCptr;
@end

NS_ASSUME_NONNULL_END
