/**
* Copyright (C) 2003-2025, Foxit Software Inc..
* All Rights Reserved.
*
* http://www.foxitsoftware.com
*
* The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
* distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
* is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
* Review legal.txt for additional license and legal information.
*/

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, FSFillSignEditType) {
    FSFillSignEditTypeUnknown = -1,
    FSFillSignEditTypeLeftTop = 0,
    FSFillSignEditTypeLeftMiddle,
    FSFillSignEditTypeLeftBottom,
    FSFillSignEditTypeMiddleTop,
    FSFillSignEditTypeMiddleBottom,
    FSFillSignEditTypeRightTop,
    FSFillSignEditTypeRightMiddle,
    FSFillSignEditTypeRightBottom,
    FSFillSignEditTypeFull,
    FSFillSignEditTypeStartPoint,
    FSFillSignEditTypeEndPoint,
};

typedef NS_ENUM(NSUInteger, FSFillSignType) {
    FSFillSignTypeUnknow = 0,
    FSFillSignTypeText = FSReadToolSettingsTypeFillSignText,
    FSFillSignTypeSegText = FSReadToolSettingsTypeFillSignSegText,
    FSFillSignTypeCheck = FSReadToolSettingsTypeFillSignCheckMark,
    FSFillSignTypeX = FSReadToolSettingsTypeFillSignCrossMark,
    FSFillSignTypeDot = FSReadToolSettingsTypeFillSignDot,
    FSFillSignTypeLine = FSReadToolSettingsTypeFillSignLine,
    FSFillSignTypeRoundrect = FSReadToolSettingsTypeFillSignRoundRectangle,
    FSFillSignTypeProfile = FSReadToolSettingsTypeFillSignProfile,
};

typedef NS_ENUM(NSUInteger, FillSignEditStatus){
    FillSignEditStatus_Normal,
    FillSignEditStatus_Select,
    FillSignEditStatus_Editing,
};

typedef NS_ENUM(NSUInteger, FillSignXPosition){
    FillSignXPosition_Left,
    FillSignXPosition_Center,
};

@interface FillSignUtility : NSObject

@end

NS_ASSUME_NONNULL_END
