/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSViewController.h"

@class UIExtensionsManager;
@protocol SignatureAppearanceLocationDelegate <NSObject>
- (void)locationBack:(BOOL) isLocationOpen location:(NSString *) location;
@end

@interface SignatureAppearanceLocationViewController : FSViewController

@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) BOOL isLocationOpen;
@property (nonatomic, copy) NSString *location;
@property (nonatomic, weak) id<SignatureAppearanceLocationDelegate> delegate;


- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager locationOpen:(BOOL) isLocationOpen location:(NSString*) location;
@end
