/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSTableViewController.h"

@class UIExtensionsManager;
@protocol SignatureAppearanceReasonDelegate <NSObject>
- (void)reasonBack:(BOOL) isReasonOpen reason:(NSString *) reason;
@end

@interface SignatureAppearanceReasonViewController : FSTableViewController

@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) BOOL isReasonOpen;
@property (nonatomic, strong) NSString *reason;
@property (nonatomic, weak) id<SignatureAppearanceReasonDelegate> delegate;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager reasonOpen:(BOOL) isReasonOpen reason:(NSString *) reason;

@end

