/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSViewController.h"

@class UIExtensionsManager;
@protocol SignatureAppearanceViewDelegate <NSObject>
- (void)cancelSign:(AnnotationSignature *)currentSignature;
- (void)saveSign:(AnnotationSignature *)currentSignature;
@end

@interface SignatureAppearanceViewController : FSTableViewController<UITextFieldDelegate>

@property (nonatomic, weak) UIExtensionsManager *extensionsManager;

@property (nonatomic, assign) BOOL isReasonOpen;
@property (nonatomic, strong) NSString *reason;
@property (nonatomic, assign) BOOL isLocationOpen;
@property (nonatomic, strong) NSString *location;
@property (nonatomic, strong) NSString *titleName;
@property (nonatomic, strong) AnnotationSignature *currentSignature;
@property (nonatomic, strong) NSMutableArray *titleArray;
@property (nonatomic, weak) id<SignatureAppearanceViewDelegate> delegate;
@property (nonatomic, strong) UIImage *image;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager signature:(AnnotationSignature *)signature image:(UIImage *)img;
@end

