/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

#import <FoxitRDK/FSPDFViewControl.h>

@interface SignatureView : UIView {
    void *dibBuf;
}

@property (nonatomic, assign) CGRect rectSigPart;
@property (nonatomic, assign) int color;
@property (nonatomic, assign) float diameter;
@property (nonatomic, assign) BOOL hasChanged;
@property (nonatomic, assign) BOOL fromDraw;
@property (nonatomic, strong) UIImage *picSignature;
@property (nonatomic, assign) CGRect picRect;
@property (nonatomic, copy) void (^signHasChangedCallback)(BOOL hasChanged);

- (instancetype)initWithSize:(CGSize)size;
- (instancetype)init NS_UNAVAILABLE;

- (void)clear;
- (void)loadSignature:(NSData *)dibData rect:(CGRect)rect;
- (void)loadPicSignature:(UIImage *)image;
- (UIImage *)getCurrentImage;
- (NSData *)getCurrentDib;
- (void)invalidateRect:(FSRectF *)rect;
@end

@interface FSPSICallbackImp : NSObject <FSPSICallback>

@property (nonatomic, weak) SignatureView *sigView;

- (id)initWithSigView:(SignatureView *)view;

@end
