/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSViewController.h"

@class SignatureView;
@class AnnotationSignature;
@class UIExtensionsManager;
@protocol FSPropertyMainViewDelegate;

typedef void (^SignatureCancelHandler)(void);
typedef void (^SignatureSaveHandler)(void);

@interface SignatureViewController : FSViewController <FSPropertyMainViewDelegate>

@property (nonatomic, strong) AnnotationSignature *currentSignature;
@property (nonatomic, copy) SignatureCancelHandler cancelHandler;
@property (nonatomic, copy) SignatureSaveHandler saveHandler;
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) BOOL isFieldSig;
@property (nonatomic, assign) BOOL isShowed;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;

@end
