/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "TbBaseBar.h"
#import "UIFSDocProviderCallback.h"
#import "FSAnnotHandler.h"

@protocol IGestureEventListener;

@interface FormAnnotHandler : FSAnnotHandler <FSFillerAssistCallback, IAnnotHandler, IDocEventListener, IRotationEventListener> {
    BOOL _keyboardShown;
    CGRect _originalRect;
    float _keyboardHeight;
    NSUInteger _inputCharacterLocation;
    __weak FSTaskServer *_taskServer;
    int _focusedWidgetIndex;
    BOOL _needRotate;
    dispatch_semaphore_t _lock;
    NSString* _changeText;
}

@property (nonatomic, strong) NSTimer *formTimer;
@property (nonatomic, weak) FSTimer *formTimerCallback;
@property (nonatomic, assign) BOOL hasFormChanged;
@property (nonatomic, assign) BOOL canDragFormControl;
@property (nonatomic, assign) BOOL editFormControlNeedTextInput;
@property (nonatomic, assign) BOOL editFormControlNeedSetCursor;
@property (nonatomic, assign) BOOL editFormControlNeedDatePicker;
@property (nonatomic, assign) CGRect currentEditRect;
@property (nonatomic, strong) FSToolbar *formNaviBar;
@property (nonatomic, strong) FSToolbar *textFormNaviBar;
@property (nonatomic, strong) FSFiller *formFiller;
@property (nonatomic, strong) FSForm *form;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (FSToolbar *)buildFormNaviBar;
- (void)endTextInputWithExit;
- (void)setEnableHighlightForm:(BOOL)enableHighlightForm;
- (void)setHighlightFormColor:(UIColor *)highlightFormColor;
- (BOOL)imageFieldBrowFileWithFileFilter:(NSString *)fileFilter;
- (void)setTextToCurrentTextFiled:(NSString *)text;
- (void)killFocus;
@end
