/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface FSFullScreenToolbarMgr : NSObject

@property (nonatomic, strong) FSScrollToolbar *floatyToolbar;
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, strong) FSFullScreenTopbar *smallTopToolbar;
@property (nonatomic, strong) FSFullScreenBottombar *smallBottomToolbar;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)installFullScreenToolbar;
- (void)showFullScreenToolbar:(BOOL)bShow;
- (void)buildFullScreenToolbar;
- (void)registerEventListens;

- (void)installTopbar;
- (void)installBottombar;
- (void)removeTopbar;
- (void)removeBottombar;

- (void)setHiddenBottomToolbar:(BOOL)isHiddenBottomToolbar;
- (void)setHiddenTopToolbar:(BOOL)hiddenTopToolbar;
@end

NS_ASSUME_NONNULL_END
