/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN
@class FSHistoryDataItem;
@class FSHistoryDataCollectionCell;
@interface FSHistoryDataView : UIView<UICollectionViewDelegate, UICollectionViewDataSource>
@property (nonatomic, strong) __kindof UICollectionView *collectionView;
@property (nonatomic, copy) NSArray<FSHistoryDataItem *> *dataSource;
- (FSHistoryDataItem *)dataForIndexPath:(NSIndexPath *)indexPath;
- (void)configureCell:(FSHistoryDataCollectionCell *)cell atIndexPath:(NSIndexPath *)indexPath withDataItem:(FSHistoryDataItem *)dataItem;
- (__kindof FSHistoryDataCollectionCell *)collectionView:(nonnull UICollectionView *)collectionView dequeueReusableCellWithIdentifier:(NSString *)identifier forIndexPath:(NSIndexPath *)indexPath withDataItem:(FSHistoryDataItem *)dataItem;
@end

NS_ASSUME_NONNULL_END
