/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSCollectionViewController.h"
#import "FSThumbnailViewController.h"

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, FSThumbnailChildType) {
    FSThumbnailChildTypeAll = 0,
    FSThumbnailChildTypeAnnoted,
    FSThumbnailChildTypeBookmark,
};

typedef void (^DoneBlock)(int);

@interface FSLinkThumbnailViewController : FSCollectionViewController

@property (nonatomic, strong, readonly) FSPDFDoc *copyedDoc;
@property (nonatomic, assign) BOOL isEditing;
@property (nonatomic, copy) DoneBlock doneBlock;
@property (nonatomic, assign) int startPageIndex;

- (void)selectOrDeselectAll;
- (NSUInteger)getNumberOfItemsInCollectionView;
- (int)getPageIndexInCollectionViewAtItem:(NSInteger)item;
- (NSArray <NSNumber *> *)getSelectedItemsForOrderedAscending;

@end

NS_ASSUME_NONNULL_END
