/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSMoreAnimateView.h"

@interface FSMoreAnimateView ()

@property (nonatomic, strong) UIControl *backGroundCtrl;

@end

@implementation FSMoreAnimateView

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (instancetype)init{
    if (self = [super init]){
        
        [self arrangeView];
    }
    return self;
}

- (void)arrangeView{
    
    self.backgroundColor = [UIColor blackColor];
    
    [self addSubview:self.backGroundCtrl];
    
    [self setViewConstraints];
}

- (UIControl *)backGroundCtrl{
    if (!_backGroundCtrl) {
        _backGroundCtrl = [[UIControl alloc] init];
        _backGroundCtrl.isAccessibilityElement = YES;
        _backGroundCtrl.backgroundColor = [UIColor clearColor];
        [_backGroundCtrl addTarget:self action:@selector(backGroundTap) forControlEvents:UIControlEventTouchUpInside];
    }
    return _backGroundCtrl;
}

- (void)backGroundTap{
    if (self.tapBackgroundBlock) {
        self.tapBackgroundBlock();
    }
}

- (void)setViewConstraints{
    
    [self.backGroundCtrl mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.equalTo(self);
    }];
}


@end
