/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

typedef void (^TapHandleBlock)(void);

NS_ASSUME_NONNULL_BEGIN

@interface FSMoreHeaderView : UIButton
@property (nonatomic, strong) UIImageView *pdfImageView;
@property (nonatomic, strong) UIImage *localIconImage;
@property (nonatomic, strong) UILabel *pdfNameLabel;
@property (nonatomic, strong) UILabel *pdfInfoLabel;
@property (nonatomic, copy) TapHandleBlock tapHandleBlock;

- (void)remakeImageViewContraints:(BOOL)isVertical;
- (void)remakeLableViewContraints:(BOOL)headerViewHidden;
- (void)removeAllSubViews;
- (void)arrangeView;
@end

NS_ASSUME_NONNULL_END
