/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSTableViewPopoverController.h"

NS_ASSUME_NONNULL_BEGIN

typedef void (^HandlePanBlock)(UIPanGestureRecognizer *panGesture, BOOL needOperate);

@interface FSMoreTableViewController : FSTableViewPopoverController

@property (nonatomic, strong) NSDictionary<NSNumber*,MoreMenuGroup*> *groupDic;
@property (nonatomic, strong) NSArray<NSNumber*> *groupTags;
@property (nonatomic, strong) NSArray<MoreMenuItem*> *menuItemArray;
@property (nonatomic, weak) UIExtensionsManager *extensionsMgr;
@property (nonatomic, copy) HandlePanBlock handlePanBlock;
@property (nonatomic, assign) BOOL thumbnailHidden;

- (instancetype)initWithServices:(id<FSViewControllerServices>)services showStyle:(FSTableViewPopoverShowStyle)showStyle;
- (void)resetPopverSize;
- (CGFloat)getTableViewHeight;
- (void)getDocInfo;
- (void)setFileLocationIcon:(UIImage *)icon;
@end


NS_ASSUME_NONNULL_END
