/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */
#import "UIExtensionsManager.h"
#import "FSMoreTableViewController.h"


NS_ASSUME_NONNULL_BEGIN

@interface MoreMenuView ()
@property (nonatomic, strong) NSMutableSet<id<IMoreMenuViewListener>> *listeners;
@property (nonatomic, assign) BOOL hidden;
@property (nonatomic, strong) FSMoreTableViewController *tableViewCtrl;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)setHidden:(BOOL)hidden animate:(BOOL)animated;
- (void)setHidden:(BOOL)hidden animate:(BOOL)animated completion:(void (^ __nullable)(void))completion;

- (void)openFileInfo;
- (void)closeFileInfo:(void (^ __nullable)(void))completion;

@end


NS_ASSUME_NONNULL_END
