/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSOutlineTableViewCell.h"

@implementation FSOutlineTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (void)setEditing:(BOOL)editing animated:(BOOL)animated{
    [super setEditing:editing animated:animated];
    
    FSItem *pageNumItem = (FSItem *)self.rightView;
    if (pageNumItem) {
        pageNumItem.enabled = editing && self.canEditBookmark;
    }
    
    if (self.titleLableItem) {
        self.titleLableItem.enabled = editing && self.canEditBookmark;
    }
}

- (void)layoutSubviews{
    [super layoutSubviews];
    
    for (UIView * view in self.subviews) {
        if ([NSStringFromClass([view class]) rangeOfString: @"Reorder"].location != NSNotFound) {
            for (UIView * subview in view.subviews) {
                if ([subview isKindOfClass: [UIImageView class]]) {
                    ((UIImageView *)subview).image = FSImageNamed(@"panel_outline_more");
                    ((UIImageView *)subview).contentMode = UIViewContentModeCenter;
                    break;
                }
            }
            break;
        }
    }
}

- (FSItem *)titleLableItem{
    if (!_titleLableItem) {
        _titleLableItem = [FSItem createItemWithTitle:nil];
        [_titleLableItem setTitleEdgeInsets:UIEdgeInsetsMake(0, 5, 0, 5)];
        _titleLableItem.titleLabel.hidden = YES;
        _titleLableItem.titleLabel.textColor = [UIColor clearColor];
        [self.contentView addSubview:_titleLableItem];
        [_titleLableItem mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.top.bottom.equalTo(self.estimatedTitleLabel);
            make.right.mas_lessThanOrEqualTo(self.estimatedTitleLabel);
        }];
        [_titleLableItem.titleLabel setContentCompressionResistancePriority:UILayoutPriorityDefaultLow forAxis:UILayoutConstraintAxisHorizontal];
        [_titleLableItem setContentCompressionResistancePriority:UILayoutPriorityDefaultLow forAxis:UILayoutConstraintAxisHorizontal];
        
    }
    return _titleLableItem;
}

- (void)setHighlighted:(BOOL)highlighted custom:(BOOL)custom{
    if (self.isMoving) {
        return;
    }
    [super setHighlighted:highlighted custom:custom];
}

@end
