/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "PanelController.h"
#import "FSSearchViewController.h"
#import "OutlinePanel.h"

typedef void (^GetBookmarksFinishHandler)(NSMutableArray *bookmark);

@interface OutlineButton : UIButton

@property (nonatomic, strong) NSIndexPath *indexPath;

@end

typedef void (^bookmarkGotoPageHandler)(int page);

/** @brief The view controller for bookmarks. */
@interface OutlineViewController : FSSearchViewController{
    __weak UIExtensionsManager *_extensionsManager;
    __weak FSPDFViewCtrl *_pdfViewCtrl;
}
@property (nonatomic, weak) OutlinePanel *panel;
@property (copy, nonatomic) bookmarkGotoPageHandler bookmarkGotoPageHandler;
@property (assign, nonatomic) BOOL hasParentBookmark;
@property (nonatomic, strong) NSMutableArray *allBookmarks;
@property (nonatomic, strong, readonly) FSItem *addItem;
@property (nonatomic, assign) int treeLevel;
@property (nonatomic, strong, readonly) NSMutableArray *currentBookmarks;
@property (nonatomic, strong, readonly) FSBookmark *currentParentBookmark;
@property (nonatomic, assign) BOOL canEditBookmark;

- (id)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager panelController:(FSPanelController *)panelController;
- (id)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)loadData:(FSBookmark *)parentBookmark;
- (void)clearData;

@end
