/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPageNavigationSlider.h"

@interface FSPageNavigationSlider ()

@property(nonatomic,assign) CGRect thumbRect;

@end

@implementation FSPageNavigationSlider

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (CGRect)thumbRectForBounds:(CGRect)bounds trackRect:(CGRect)rect value:(float)value{
    self.thumbRect = [super thumbRectForBounds:bounds trackRect:rect value:value];
    return self.thumbRect;
}

- (UIView *)hitTest:(CGPoint)point withEvent:(UIEvent *)event{
    
    //Uisilder is valid only when it is clicked on the slider button, and click events in other positions penetrate
    UIView *hitView = [super hitTest:point withEvent:event];
    if (hitView == self) {
        if (!CGRectContainsPoint(self.thumbRect, point)) {
            return nil;
        }
    }
    return hitView;
}

@end
