/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>
#import "PanelHost+private.h"

NS_ASSUME_NONNULL_BEGIN

@interface FSBasePanel : NSObject<IPanelSpec, IDocEventListener, IPageEventListener>
@property (nonatomic, strong) FSNavigationController *navController;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, weak, readonly) FSItem *leftItem;
@property (nonatomic, weak, readonly) FSItem *rightItem;
@property (nonatomic, strong, readonly) UIView *contentView;
@property (nonatomic, weak, readonly) FSPDFViewCtrl *pdfViewCtrl;
@property (nonatomic, weak, readonly) UIExtensionsManager *extensionsManager;
@property (nonatomic, weak, readonly) FSPanelController *panelController;

@property (nonatomic, weak) FSTableViewController *contentViewCtr;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager panelController:(FSPanelController *)panelController;

- (void)initialize;

- (void)clickedLeftItem;
- (void)clickedRightItem;

- (void)load;
- (void)unload;

- (void)quitSearch;

@end

NS_ASSUME_NONNULL_END
