/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

@class EncryptOptionViewController;
typedef void (^EncryptOptionHandler)(EncryptOptionViewController *ctrl, BOOL isCancel, NSString *openPassword, NSString *permissionPassword, BOOL print, BOOL printHigh, BOOL fillForm, BOOL addAnnot, BOOL assemble, BOOL modify, BOOL copyForAccess, BOOL copy);
typedef void (^EncryptRMSHandler)(EncryptOptionViewController *ctrl);

@interface EncryptOptionCell : FSTableViewCell
@end

@interface EncryptOptionViewController : FSViewController <UITextFieldDelegate, UINavigationControllerDelegate> {
}

@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellEncryptRMS;
@property (strong, nonatomic) IBOutlet UIButton *buttonEncryptRMS;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellOpenDoc;
@property (strong, nonatomic) IBOutlet UISwitch *switchOpenDoc;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellOpenDocPassword;
@property (strong, nonatomic) IBOutlet UITextField *textboxOpenDocPassword;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellAddLimitation;
@property (strong, nonatomic) IBOutlet UISwitch *switchAddLimitation;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellPrintDoc;
@property (strong, nonatomic) IBOutlet UISwitch *switchPrintDoc;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellFillForm;
@property (strong, nonatomic) IBOutlet UISwitch *switchFillForm;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellAnnotDoc;
@property (strong, nonatomic) IBOutlet UISwitch *switchAnnotDoc;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellAssembleDoc;
@property (strong, nonatomic) IBOutlet UISwitch *switchAssembleDoc;
@property (strong, nonatomic) IBOutlet UITableViewCell *cellEditDocument;
@property (strong, nonatomic) IBOutlet UISwitch *switchEditDocument;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellCopyAccessibility;
@property (strong, nonatomic) IBOutlet UISwitch *switchCopyAccessibility;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellExtractContent;
@property (strong, nonatomic) IBOutlet UISwitch *switchExtractContent;
@property (strong, nonatomic) IBOutlet EncryptOptionCell *cellOtherPassword;
@property (strong, nonatomic) IBOutlet UITextField *textboxOtherPassword;

@property (copy, nonatomic) EncryptOptionHandler optionHandler;
@property (copy, nonatomic) EncryptRMSHandler rmsHandler;
@property (nonatomic, strong) NSObject *currentVC;

- (IBAction)switchOpenDocValueChanged:(id)sender;
- (IBAction)switchPrintDocValueChanged:(id)sender;
- (IBAction)switchCopyAccessibilityValueChanged:(id)sender;
- (IBAction)switchAnnotDocValueChanged:(id)sender;
- (IBAction)switchAssembleDocValueChanged:(id)sender;
- (IBAction)encryptUsingRMS:(id)sender;
- (IBAction)switchFillFormValueChanged:(id)sender;
- (IBAction)switchEditDocumentValueChanged:(id)sender;
- (IBAction)switchExtractContentValueChanged:(id)sender;
- (IBAction)switchAddLimitationValueChanged:(id)sender;

@end
