/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

@interface PasswordSecurityInfo : NSObject
@property (nonatomic, copy) NSString *openPassword;
@property (nonatomic, copy) NSString *ownerPassword;
@property (nonatomic, assign) BOOL allowPrint;
@property (nonatomic, assign) BOOL allowPrintHigh;
@property (nonatomic, assign) BOOL allowFillForm;
@property (nonatomic, assign) BOOL allowAddAnnot;
@property (nonatomic, assign) BOOL allowAssemble;
@property (nonatomic, assign) BOOL allowModify;
@property (nonatomic, assign) BOOL allowCopyForAccess;
@property (nonatomic, assign) BOOL allowCopy;

- (id)initWithOpenPassword:(NSString *)openPassword ownerPassword:(NSString *)ownerPassword print:(BOOL)print printHigh:(BOOL)printHigh fillForm:(BOOL)fillForm addAnnot:(BOOL)addAnnot assemble:(BOOL)assemble modify:(BOOL)modify copyForAccess:(BOOL)copyForAccess copy:(BOOL)copy;
@end

@interface PasswordModule : NSObject <UIAlertViewDelegate>
@property (nonatomic, strong) PasswordSecurityInfo *securityInfo;
@property (nonatomic, strong) FSPDFDoc *pdfDoc;
@property (nonatomic, copy) NSString *inputPassword;

- (instancetype)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager;

- (void)tryLoadPDFDocument:(FSPDFDoc *)document guessPassword:(NSString *)guessPassword success:(void (^)(NSString *password))success error:(void (^)(NSString *description))error abort:(void (^)(void))abort;
@end
