/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface EraseUtil : NSObject
+ (NSMutableArray<FSPointF *> *)getAllPointFromInkAnnot:(FSInk *)inkAnnot;
+ (NSMutableArray<NSMutableArray<FSPointF *> *> *)getPointLinesFromInkAnnot:(FSInk *)inkAnnot;
+ (double)distanceOfTwoPoints:(FSPointF *)point1 point2:(FSPointF *)point2 ;
+ (BOOL)isInsideCircle:(FSPointF *)point circleCenterPoint:(FSPointF *)circleCenterPoint radius:(CGFloat)radius;
+ (void)addCenterPoint:(FSPointF *)p1 p2:(FSPointF *)p2 radius:(CGFloat)radius array:(NSMutableArray<FSPointF *> *)array;
+ (double)cg_distanceOfTwoPoints:(CGPoint)point1 point2:(CGPoint)point2;
+ (BOOL)cg_isInsideCircle:(CGPoint)point circleCenterPoint:(CGPoint)circleCenterPoint radius:(CGFloat)radius;
+ (void)cg_addCenterPoint:(CGPoint)p1 p2:(CGPoint)p2 radius:(CGFloat)radius array:(NSMutableArray<NSValue *> *)array;
+ (void)cg_getU:(CGPoint)point1 point2:(CGPoint)point2 circleCenterPoint:(CGPoint)point u1:(double *)u1 u2:(double *)u2 radius:(CGFloat)radius;
+ (void)getU:(FSPointF *)point1 point2:(FSPointF *)point2 circleCenterPoint:(FSPointF *)point u1:(double *)u1 u2:(double *)u2 radius:(CGFloat)radius;
@end

NS_ASSUME_NONNULL_END
