/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#if !TARGET_OS_MACCATALYST
#import <UIKit/UIKit.h>
#import "FSLanguageContainerModel.h"

#import "StrokeManager.h"


@class UIExtensionsManager;
@protocol FSPencilLanguagesDelegate <NSObject>
- (void)languagesCallBack:(NSInteger) index model:(FSLanguageContainerModel *) item;
@end

@interface FSPencilLanguagesViewController : FSTableViewController

@property (nonatomic, weak) id<FSPencilLanguagesDelegate> delegate;
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) NSInteger index;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager index:(NSInteger) index;
@end

#endif
