/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */
#if !TARGET_OS_MACCATALYST
#import <UIKit/UIKit.h>

@class UIExtensionsManager;
@protocol FSPencilRecognizeTextDelegate <NSObject>
- (void)languagesCallBack:(NSMutableArray <FSAnnot *>*)annots text:(NSString *) text;
@end

@interface FSPencilRecognizeTextViewController : FSViewController

@property (nonatomic, weak) id<FSPencilRecognizeTextDelegate> delegate;
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager annots:(NSMutableArray <FSAnnot *>*) annots;

@end
#endif
