/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "PanelController+private.h"
#import "FSSearchViewController.h"
#import "ReadingBookmarkPanel.h"
@class FileDetailViewController;

typedef void (^ReadingBookmarkGotoPageHandler)(int page);
typedef void (^ReadingBookmarkSelectionHandler)(void);
typedef void (^ReadingBookmarkDeleteHandler)(void);

@interface ReadingBookmarkViewController : FSSearchViewController <IPanelChangedListener> {
    __weak FSPDFViewCtrl *_pdfViewCtrl;
}

@property (nonatomic, copy) ReadingBookmarkGotoPageHandler bookmarkGotoPageHandler;
@property (nonatomic, copy) ReadingBookmarkSelectionHandler bookmarkSelectionHandler;
@property (nonatomic, copy) ReadingBookmarkDeleteHandler bookmarkDeleteHandler;

//a common way to do for bookmark and annotation

@property (nonatomic, strong) NSMutableArray *arrayBookmarks;
@property (nonatomic, assign) BOOL isContentEditing;
@property (nonatomic, assign) BOOL isShowMore;
@property (nonatomic, strong) NSIndexPath *moreIndexPath;
@property (nonatomic, weak) FSPanelController *panelController;
@property (nonatomic, weak) ReadingBookmarkPanel *panel;

- (id)initWithExtensionsManager:(UIExtensionsManager *)extensionsManager panelController:(FSPanelController *)panelController;
- (void)loadData;
- (void)clearData:(BOOL)fromPDF;
- (NSUInteger)getBookmarkCount;

- (void)renameBookmarkWithIndex:(NSInteger)index;

- (void)hideCellEditView;

@end
