/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "MagnifierView.h"
#import "UIExtensionsManager.h"

/**@brief A text markup tool handler to handle its own events. */
@interface RedactToolHandler : NSObject <IToolHandler>
@property (nonatomic, assign) FSAnnotType type;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (FSAnnot *)addAnnotToPage:(int)pageIndex withRect:(FSRectF *)rect needQuads:(BOOL)needQuads;
- (FSAnnot *)addAnnotToPage:(int)pageIndex withRect:(FSRectF *)rect;
@end
