/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "UIExtensionsManager.h"

/** @brief A tool handler to select texts on the page, or for adding annotations. */
@interface SelectToolHandler : NSObject <IToolHandler, UIPopoverControllerDelegate, IRotationEventListener, IScrollViewEventListener, IGestureEventListener, IPageEventListener, IDocEventListener, IWindowFrameChangedListener>

@property (nonatomic, assign) BOOL isEdit;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)clearSelection;
- (NSString *)copyText;
- (void )deSelect;

@end
