/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef SettingBar_private_h
#define SettingBar_private_h

#import <FoxitRDK/FSPDFViewControl.h>
#import <UIKit/UIKit.h>
#import "FSSettingBar.h"
#import "FSSettingContentView.h"
#import "FSSettingBarUtilities.h"


@interface FSSettingBar ()
@property (nonatomic, strong) FSSettingContentView* _Nullable settingView;
@property (nonatomic, strong) FSViewSettingManager* _Nullable viewSettingManager;

/**
 * @brief    Initialize the setting bar.
 *
 * @param[in]    extensionsManager   The extensions manager.
 *
 * @return    The setting bar instance.
 */
- (instancetype _Nullable )initWithUIExtensionsManager:(UIExtensionsManager *_Nullable)extensionsManager;

- (void)updateLayoutButtonsWithLayout:(PDF_LAYOUT_MODE)layout;

- (void)didClickItemWithType:(SettingItemType)type;

- (void)initContentView;

- (void)updateContentViewLayoutHeight;

@end

#endif /* SettingBar_private_h */
