/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>
#import "FSSettingBar+private.h"

NS_ASSUME_NONNULL_BEGIN

@interface FSSettingBarHorizontalCell : UICollectionViewCell

@property(nonatomic, strong) NSString* itemImageName;
@property(nonatomic, strong) NSString* itemSelectedImageNameWithColorCell;
@property(nonatomic, strong) NSString* itemTitleName;
@property(nonatomic, assign) FSSettingBarCellSectionType sectionType;
@property(nonatomic, assign) SettingItemType itemType;
@property(nonatomic, assign) BOOL cellSelected;
@property(nonatomic, assign) BOOL enabled;

- (void)setCellInfo:(NSString*)itemTitleName itemImageName:(NSString*)itemImageName sectionType:(FSSettingBarCellSectionType)sectionType itemType:(SettingItemType)itemType pageColor:(UIColor*)pageColor;

@end

NS_ASSUME_NONNULL_END
