/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>
#import "FSSettingBar.h"

typedef enum{
    SectionTypeHorizontalPage,
    SectionTypeHorizontalColor,
    SectionTypeVertical,
}FSSettingBarCellSectionType;

#define InfoKeypath(KEYPATH) @keypath([FSSettingBarCellInfo new], KEYPATH)
NS_ASSUME_NONNULL_BEGIN

@interface FSSettingBarCellInfo : NSObject
@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *imageName;
@property (nonatomic, strong) NSString *pageColor;
@property (nonatomic, assign) SettingItemType itemType;
@property (nonatomic, assign) FSSettingBarCellSectionType sectionType;
@property (nonatomic, strong) NSNumber *continusON;
@property (nonatomic, strong) NSNumber *pageRTLON;
@property (nonatomic, assign) BOOL singlePage;
@property (nonatomic, assign) BOOL selected;
@property (nonatomic, assign) BOOL hidden;
@property (nonatomic, assign) BOOL enabled;
@property (nonatomic, assign) BOOL defaultEnabled;
- (instancetype)initWithItemType:(SettingItemType)itemType;
@end

NS_ASSUME_NONNULL_END
