/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>
#import "FSSettingBar+private.h"

NS_ASSUME_NONNULL_BEGIN
@protocol FSSettingBarVerticalCellDelegate <NSObject>

- (void)didClickSwitchBtn:(BOOL)on cellType:(SettingItemType)cellType;
@end

@interface FSSettingBarVerticalCell : UICollectionViewCell

@property(nonatomic, weak) id<FSSettingBarVerticalCellDelegate>delegate;
@property(nonatomic, strong) UISwitch *switchBtn;
@property(nonatomic, assign) BOOL enabled;
@property(nonatomic, assign) BOOL cellSelected;

- (void)setCellInfo:(NSString*)itemTitleName itemImageName:(NSString*)itemImageName switchBtnON:(BOOL)switchBtnON cellType:(SettingItemType)cellType;

@end

NS_ASSUME_NONNULL_END
