/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@interface FSSettingContentView : UIView
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) NSInteger currentShowItemType;
@property (nonatomic, assign, readonly) CGFloat layoutHeight;
- (instancetype)initWithFrame:(CGRect)frame extensionsManager:(UIExtensionsManager *)extensionsManager;
- (void)reloadWithData:(NSMutableArray<NSMutableArray*>*)dataSource;
- (void)reloadData;
- (void)reloadDataWithFrameChanged:(CGFloat)newFrameWidth;
@end

NS_ASSUME_NONNULL_END
