/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface FSCustomStampAttributes : NSObject<YYModel>
@property (nonatomic, assign) NSTimeInterval creatTime;
- (FSPDFDoc *)currentDoc;
@end

@interface FSCustomTextStampAttributes : FSCustomStampAttributes
@property (nonatomic, copy) NSString *text;
@property (nonatomic, copy) NSString *creatAuthor;
@property (nonatomic, copy) NSString *currentAuthor;
@property (nonatomic, assign) BOOL hasAuthor;
@property (nonatomic, assign) BOOL hasDate;
@property (nonatomic, assign) BOOL hasTime;
@property (nonatomic, copy) NSString *colorHex;
- (NSArray<NSString *> *)colorsHex;
- (FSPDFDoc *)creatDynamicStampDoc;
@end

@interface FSCustomImageStampAttributes : FSCustomStampAttributes
@property (nonatomic, copy) NSString *imageName;
@property (nonatomic, strong) UIImage *image;
@property (nonatomic, assign) CGFloat opacity;
- (CGSize)stampScaleByImage;
- (CGSize)imageConverToPDFSize;
- (FSPDFDoc *)creatImageStampDoc;
- (void)copyImageFileWithPath:(NSString *)path;
- (void)clearImage;
@end

NS_ASSUME_NONNULL_END
