/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

typedef void (^SelectIconHandler)(int icon);
typedef void (^CloseHandle)(void);

@interface StampButton : UIButton
@property (nonatomic, assign) NSInteger stampIcon;
- (void)setLayerBorderWidth:(CGFloat)borderWidth;
@end

@interface StampCell : UITableViewCell

@end

@interface StampIconController : FSViewController 

@property (nonatomic, assign) int currentIcon;
@property (nonatomic, copy) SelectIconHandler selectHandler;
@property (nonatomic, copy) CloseHandle closeHandler;

- (instancetype)initWithUIExtensionsManager:(UIExtensionsManager *)extensionsManager toolSettings:(FSReadToolSettings *)toolSettings;

@end
