/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import <Foundation/Foundation.h>

#define CUSTOM_TEXT_STAMP_FILE [CUSTOM_TEXT_STAMP_PATH stringByAppendingString:@"/TextStamp"]
#define CUSTOM_IMAGE_STAMP_FILE [CUSTOM_IMAGE_STAMP_PATH stringByAppendingString:@"/ImageStamp"]
#define CUSTOM_IMAGE_STAMP_IMAGE_CACHE CREATE_DIR_IF_NOT_PATH_AND_APPENDING_PATH(CUSTOM_IMAGE_STAMP_PATH, @"/ImageCache")

static NSString *const Key_Identity = @"Identity";

@class FSCustomStampAttributes;
@class FSCustomTextStampAttributes;
@class FSCustomImageStampAttributes;
@interface StampUtil : NSObject

+ (NSString *)GetJapaneseEras:(int)year month:(int)month day:(int)day;

+ (NSString *)getJapaneseDate:(BOOL)isEra;

+ (NSString *)stampIconConvert2Appearance:(int)index;
@end

@interface FSCustomStamps : NSObject<YYModel>
@property (nonatomic, strong) NSMutableArray<__kindof FSCustomStampAttributes *> *stamps;
@end

@interface FSCustomTextStamps : FSCustomStamps
- (NSMutableArray<FSCustomTextStampAttributes *> *)textStampes;
@end

@interface FSCustomImageStamps : FSCustomStamps
- (NSMutableArray<FSCustomImageStampAttributes *> *)imageStampes;
@end

@interface FSCustomTextAndImageStamps : NSObject
@property (class, nonatomic, strong, readonly) NSMutableArray *customStamps;
@property (class, nonatomic, strong, readonly) FSCustomTextStamps *textStamps;
@property (class, nonatomic, strong, readonly) FSCustomImageStamps *imageStamps;
@end

