/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef ThumbnailModule_Private_h
#define ThumbnailModule_Private_h

#import "FSThumbnailCache.h"
#import "ThumbnailModule.h"
@protocol IThumbnailEventListener <NSObject>
@required
- (void)onThumbnailChanged:(BOOL)isHidden;
@end

@interface ThumbnailModule ()
@property (nonatomic, strong) FSThumbnailCache *thumbnailCache;
@property (nonatomic, assign) BOOL showShareExtactItem;

- (BOOL)isThumbnailViewHidden;
- (void)removeThumbnailCacheOfPageAtIndex:(NSUInteger)pageIndex;
- (void)clearThumbnailCachesForPDFAtPath:(NSString *)path;
- (void)registerThumbnailEventListener:(id<IThumbnailEventListener>)listener;
- (void)unregisterThumbnailEventListener:(id<IThumbnailEventListener>)listener;
@end
#endif /* ThumbnailModule_Private_h */
