/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#ifndef FSReadToolbarItem_Private_h
#define FSReadToolbarItem_Private_h

#import "FSReadToolbarItem.h"

@interface FSReadToolSettings ()
@property (nonatomic, assign) int pencilStyle;//pen = 0 ,brush = 1
@property (nonatomic, assign) int eraseStyle;//partial = 0 ,whole = 1
- (void)setPropertyColor:(UIColor *)propertyColor;
@end

@interface FSReadToolbarItem ()
@property (nonatomic, assign) BOOL enableProperty;
@property (nonatomic, copy) NSString  *imageName;
@property (nonatomic, copy) NSString *title;
@property (nonatomic, copy) NSString *selectTitle;
@property (nonatomic, strong) UIImage  *image;
@property (nonatomic, strong) FSReadToolSettings *toolSettings;
@property (nonatomic, strong) UIColor *propertyColor;
@property (nonatomic, strong) FSMainToolbarItem *toolbarItem;
@property (nonatomic, weak) UIExtensionsManager *extensionsManager;
@property (nonatomic, assign) FSItemContentType itemContentType;

- (instancetype)initWithToolSettingType:(FSReadToolSettingsType)settingType extensionsManager:(UIExtensionsManager *)extensionsManager;
- (instancetype)initWithToolSettingType:(FSReadToolSettingsType)settingType extensionsManager:(UIExtensionsManager *)extensionsManager addTool:(BOOL)addTool;
- (void)selectFormSuperBar;
+ (FSItem *)createItemFromReadToolbarItem:(FSReadToolbarItem *)readToolbarItem needBackground:(BOOL)needBackground;
@end


@interface FSAddToolsTitleItem : NSObject
@property (nonatomic, copy) NSString *title;
@property (nonatomic, assign) BOOL unfold;
@property (nonatomic, copy) NSArray <FSReadToolbarItem *> *subReadItems;
- (instancetype)initWithTitle:(NSString *)title subReadItems:(NSArray <FSReadToolbarItem *> *)subReadItems;
@end

#endif /* FSReadToolSettingItem_Private_h */
