/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSToolbar+Private.h"

typedef NS_ENUM(NSUInteger, FSScrollToolbarItemPosition) {
    FSScrollToolbarItemPositionScroll = 100 ,
    FSScrollToolbarItemPositionRight,
};
NS_ASSUME_NONNULL_BEGIN

@interface FSScrollToolbar : FSToolbar

@property (nonatomic,assign)UIEdgeInsets horizontalScrollBarEdgeInsets;
@property (nonatomic,assign)UIEdgeInsets verticalScrollBarEdgeInsets;

- (NSUInteger)getItemCountWithPosition:(FSItemPosition)position NS_UNAVAILABLE;
- (void)addEvenItem:(__kindof UIView *)item NS_UNAVAILABLE;
- (void)addItem:(__kindof UIView *)item atPosition:(FSItemPosition)position NS_UNAVAILABLE;
- (void)removeItem:(__kindof UIView *)item atPosition:(FSItemPosition)position NS_UNAVAILABLE;
- (void)removeItemAtPosition:(FSItemPosition)position index:(NSUInteger)index NS_UNAVAILABLE;

- (void)addItem:(__kindof UIView *)item spacing:(CGFloat)spacing atPosition:(FSScrollToolbarItemPosition)position;
- (void)removeItemAtPosition:(FSScrollToolbarItemPosition)position;
- (void)scrollTo:(UIView *)item;
@end

NS_ASSUME_NONNULL_END
