/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSUndo.h"

@class RedactAnnotHandler;

NS_ASSUME_NONNULL_BEGIN

@interface FSUndoGroup : UndoItem
@property (nonatomic, strong) NSMutableArray<NSNumber*> *pageArray;
- (NSArray<NSNumber*> *)getIndexArray;
- (void)removePageIndex:(NSArray<NSNumber*> *)pageIndexs;
- (void)removePageAttributes:(FSAnnotAttributes*)attributes;
+ (instancetype)itemForUndoAddRdactAnnotsWithAttributes:(NSArray<FSAnnotAttributes*> *)attributesArray pageArray:(NSArray<NSNumber*> *)pageArray annotHandler:(RedactAnnotHandler*)annotHandler curDoc:(FSPDFDoc*)curDoc;
+ (instancetype)itemForUndoDeleteRdactAnnotsWithAttributes:(NSArray<FSAnnotAttributes*> *)attributesArray pageArray:(NSArray<NSNumber*> *)pageArray annotHandler:(RedactAnnotHandler*)annotHandler curDoc:(FSPDFDoc*)curDoc;
@end


NS_ASSUME_NONNULL_END
