/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "FSPermissionUtilty.h"
#import "UIExtensionsManager+FSAnnotPermission.h"

@implementation FSPermissionUtilty

+ (BOOL)canNotEnterForm:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return !extensionsMgr.enableModifyDocument || [Utility canNotEnterForm:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canAddAnnot:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return [Utility canAddAnnot:extensionsMgr.pdfViewCtrl];
}

//edit annots: FSAnnotAudio, FSAnnotVideo, FSAnnotLink
+ (BOOL)canAddEditAnnot:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAddEditAnnot:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canFillForm:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canFillForm:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canAddSign:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAddSign:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canAssemble:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAssemble:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canModifyContents:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canModifyContents:extensionsMgr.pdfViewCtrl];
}

+ (BOOL)canAddAnnotToDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAddAnnotToDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

//edit annots: FSAnnotAudio, FSAnnotVideo, FSAnnotLink
+ (BOOL)canAddEditAnnotToDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAddEditAnnotToDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

+ (BOOL)canFillFormInDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canFillFormInDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

+ (BOOL)canAddSignToDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAddSignToDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

+ (BOOL)canAssembleDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canAssembleDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

+ (BOOL)canModifyContentsInDocument:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return extensionsMgr.enableModifyDocument && [Utility canModifyContentsInDocument:extensionsMgr.pdfViewCtrl.currentDoc];
}

+ (BOOL)canApplyRedaction:(UIExtensionsManager*)extensionsMgr{
    if (!extensionsMgr) {
        return NO;
    }
    return [Utility canApplyRedaction:extensionsMgr.pdfViewCtrl.currentDoc] && [extensionsMgr annotsPermissionCanModify] && [extensionsMgr annotsPermissionCanDelete];
}

@end
