/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.
 */

#import "NSSet+containsAnyObjectInArray.h"

@implementation NSSet (containsAnyObjectInObjectTypes)

- (BOOL)fs_containsAnyObjectInSet:(NSSet *)set {
    for (id obj in set) {
        if ([self containsObject:obj]) {
            return true;
        }
    }
    return false;
}


- (BOOL)fs_containsAnyObjectInArray:(NSArray *)array {
    for (id obj in array) {
        if ([self containsObject:obj]) {
            return true;
        }
    }
    return false;
}

- (BOOL)fs_containsAnyObjectNotInArray:(NSArray *)array {
    for (id obj in self) {
        if (![array containsObject:obj]) {
            return true;
        }
    }
    return false;
}

@end
