/**
 * Copyright (C) 2003-2025, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and is the proprietary of Foxit Software Inc.. It is not allowed to 
 * distribute any parts of Foxit PDF SDK for iOS to third party or public without permission unless an agreement 
 * is signed between Foxit Software Inc. and customers to explicitly grant customers permissions.
 * Review legal.txt for additional license and legal information.

 */

import UIKit

class ViewController: UITableViewController {
    
    func presentAlert(_ alertControllerToPresent: UIViewController, animated flag: Bool, completion: @escaping () -> Void) {
        self.present(alertControllerToPresent, animated: flag, completion: completion)
    }
    
    let buttonList = ["pdf2txt", "outline", "annotation", "docinfo", "render", "signature", "image2pdf", "watermark", "search", "graphics_objects"]
    let descriptionList = ["Extract text from a PDF document to a TXT file.", "Edit outline (aka bookmark) appearances and titles.", "Add annotations and export annotations to a JSON file.", "Export document info to a TXT file.", "Render a specified page to Bitmap.", "Add a signature to PDF, sign PDF and verify the signature.", "Convert images to PDF files.", "Add text, image and PDF-page watermarks to PDF file.", "Search PDF files.", "Create a PDF Doc with graphics objects."]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
       
        let docDir = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0]
        print("\(docDir)")
        self.tableView.tableFooterView = nil
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.buttonList.count
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> CustomCell {
        let testID = "testID"
        let cell = tableView.dequeueReusableCell(withIdentifier: testID)!
        let cusCell = cell as! CustomCell
        let row = indexPath.row
        
        cusCell.funcDescription.text = (descriptionList[row])
        cusCell.runBtn.tag = row
        cusCell.runBtn.setTitle((buttonList[row]), for: .normal)
        cusCell.runBtn.titleLabel?.numberOfLines = 0
        cusCell.runBtn.titleLabel?.textAlignment = .center
        cusCell.accessoryType = .none
        
        cusCell.delegate = self
        return cusCell
    }
}
